// C Source File
// Created 10/08/2004; 15:01:18

#include <tigcclib.h>
#include "..\System\Screen.h"

void *SaveScreen;

//------------------------------------
//Initilisation des buffers graphiques
//------------------------------------
void Screen_Init (void)
{
	if (!SaveScreen) SaveScreen = malloc (LCD_SIZE);
	memcpy (SaveScreen, LCD_MEM, LCD_SIZE);
	
	//Efface cran
	//ClrScr ();
}

//-----------------------------
//Libre les buffers graphiques
//-----------------------------
void Screen_Uninit (void)
{
	memcpy (LCD_MEM, SaveScreen, LCD_SIZE);
	if (SaveScreen) free (SaveScreen);
	SaveScreen = NULL;
}
