|=====================
|Gestion interruptions
|=====================
		.include  "os.h"
		
		.include  "Defines.h"
		.include  "Tbl_Errors.h"
		.include  "GFATEM.h"
		
		.xdef     Interrupt1
		.xdef     Interrupt2

		
|=========================================================================
|Interrupt1
|-------------------------------------------------------------------------
|Interruption n1  200 Hz. Gestion TIMER
|=========================================================================
_Interrupt1_SetTimer_HW1:
		move.w    __COUNTER_HARDWARE(%PC),%d0
		addi.w    #__HARDWARE_FREQUENCY,%d0
		lea.l     __COUNTER_HARDWARE(%PC),%a0
		move.w    %d0,(%a0)
		bpl	  _Interrupt1_SetTimer_HW1_next
		move.l    (%SP)+,%a0
		move.w    (%SP)+,%d0
		rte
		
_Interrupt1_SetTimer_HW1_next:			
		subi.w    #32768,%d0
		lea.l     __COUNTER_HARDWARE(%PC),%a0
		move.w    %d0,(%a0)
		
		|Execute SET_INT1
		jbsr      SET_INT1
		move.l    (%SP)+,%a0
		move.w    (%SP)+,%d0
		rte
		
Interrupt1:
		move.w    #0x2700,%SR
		move.w    %d0,-(%SP)
		move.l    %a0,-(%SP)
		
		move.w    HARDWARE_VERSION(%PC),%d0
		cmpi.w    #1,%d0
		jbeq      _Interrupt1_SetTimer_HW1
		
		|Execute SET_INT1
		jbsr      SET_INT1
		move.l    (%SP)+,%a0   
		move.w    (%SP)+,%d0      
		rte
		
|=========================================================================
|SET_INT1
|-------------------------------------------------------------------------
|Interruption  200 Hz
|=========================================================================
_SET_INT1_next:
		subi.w    #32768,%d0
		lea.l     __COUNTER_TIMER(%PC),%a0
		move.w    %d0,(%a0)
		
		|Code execut  200 Hz
		lea.l     counter_time(%PC),%a0
		addq.l    #1,(%a0)
		rts
		
SET_INT1:
		move.w    __COUNTER_TIMER(%PC),%d0
		addi.w    #__TIMER_FREQUENCY,%d0
		lea.l     __COUNTER_TIMER(%PC),%a0
		move.w    %d0,(%a0)
		bpl	  _SET_INT1_next
		rts
		

|=========================================================================
|Interrupt2
|-------------------------------------------------------------------------
|Interruption n2 dsactive 'clavier'
|=========================================================================
Interrupt2:
		move.w    #0x2700,%SR
		clr.b     0x60001B				|pokeIO (0x60001B,0);
		rte

		.end
		