|===============================
|Tokens d'Excution de fonctions
|===============================
		.include  "os.h"
		
		.include  "Defines.h"
		.include  "Tbl_Errors.h"
		.include  "TokensExec.h"
		.include  "GFATEM.h"

                .xdef     ExecFnc_At
                .xdef     ExecCmd_Print
                .xdef     ExecCmd_Dim
                .xdef     ExecCmd_Cls
                .xdef     ExecFnc_Getkey
                .xdef     ExecFnc_Abs
                .xdef     ExecCmd_Add
                .xdef     ExecFnc_Atn
                .xdef     ExecCmd_Clr
                .xdef     ExecFnc_Cos
                .xdef     ExecCmd_Dec
                .xdef     ExecCmd_Div
                .xdef     ExecFnc_Even
                .xdef     ExecFnc_Exp
                .xdef     ExecFnc_Fix
                .xdef     ExecFnc_Frac
                .xdef     ExecCmd_Inc
                .xdef     ExecFnc_Log
                .xdef     ExecFnc_Log10
                .xdef     ExecCmd_Mul
                .xdef     ExecFnc_Odd
                .xdef     ExecFnc_Sgn
                .xdef     ExecFnc_Sin
                .xdef     ExecFnc_Sqr
                .xdef     ExecFnc_Tan
                .xdef     ExecFnc_Round
                .xdef     ExecCmd_Sub
                .xdef     ExecFnc_Asc
                .xdef     ExecFnc_Bin
                .xdef     ExecFnc_Hex
                .xdef     ExecFnc_Oct
                .xdef     ExecFnc_Chr
                .xdef     ExecFnc_Left
                .xdef     ExecFnc_Len
                .xdef     ExecFnc_Mid
                .xdef     ExecFnc_Right
                .xdef     ExecFnc_Space
                .xdef     ExecFnc_Str
                .xdef     ExecFnc_String
                .xdef     ExecFnc_Upper
                .xdef     ExecFnc_Val
                .xdef     ExecFnc_Arrayfill
                .xdef     ExecFnc_Ldim
                .xdef     ExecCmd_End
                .xdef     ExecFnc_Fre
                .xdef     ExecCmd_Pause
                .xdef     ExecCmd_Swap
                .xdef     ExecFnc_Mki
                .xdef     ExecFnc_Mkl
                .xdef     ExecFnc_Mkf
                .xdef     ExecFnc_Cvi
                .xdef     ExecFnc_Cvl
                .xdef     ExecFnc_Cvf
                .xdef     ExecCmd_Setfont
                .xdef     ExecFnc_Getfont
                .xdef     ExecFnc_Lower
                .xdef     ExecCmd_Run
                .xdef     ExecFnc_Ngetchx
                .xdef     ExecFnc_Rnd
                .xdef     ExecFnc_Timer
                .xdef     ExecCmd_System
                .xdef     ExecFnc_Crslin
                .xdef     ExecFnc_Crscol
                .xdef     ExecFnc_Random
                .xdef     ExecFnc_Type
                .xdef     ExecFnc_Lval
                .xdef     ExecFnc_Varptr
                .xdef     ExecFnc_Arrptr
                .xdef     ExecFnc_Dfree
                .xdef     ExecFnc_Peek
                .xdef     ExecFnc_Dpeek
                .xdef     ExecFnc_Lpeek
                .xdef     ExecCmd_Poke
                .xdef     ExecCmd_Dpoke
                .xdef     ExecCmd_Lpoke
                .xdef     ExecCmd_Box
                .xdef     ExecCmd_Input
                .xdef     ExecCmd_Text
                .xdef     ExecCmd_Plot
                .xdef     ExecCmd_Line
                .xdef     ExecCmd_Read
                .xdef     ExecCmd_Sprite
                .xdef     ExecCmd_Get
                .xdef     ExecCmd_Put
                .xdef     ExecFnc_Point

_Exec_exit:
		rts

|==|
|AT|
|==|                
ExecFnc_At:
		TokensExec_Func_CheckArg	#2
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    13(%a5),%d0				|Conversion number 2
		move.w    #TYPE_INTEGER,%d1
		lea.l     12(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Conversion number 1
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|PARAM_PRINT_ATx = INT_num2-1;
		movea.l   16(%a5),%a0				|Number 2
		move.w    2(%a0),%d0
		subi.w    #1,%d0
		lea.l     PARAM_PRINT_ATx(%PC),%a0
		move.w    %d0,(%a0)
		
		|PARAM_PRINT_ATy = INT_num1-1;
		movea.l   4(%a5),%a0				|Number 1
		move.w    2(%a0),%d0
		subi.w    #1,%d0
		lea.l     PARAM_PRINT_ATy(%PC),%a0
		move.w    %d0,(%a0)
		
		|PARAM_PRINT_AT = TRUE;
		lea.l     PARAM_PRINT_AT(%PC),%a0
		move.w    #TRUE,(%a0)			
		
		|PARAM_PRINT_REAL_ATx = PARAM_PRINT_ATx*PARAM_FONT_DIVx;
		clr.w     %d0
		move.b    PARAM_FONT_DIVx(%PC),%d0
		move.w    PARAM_PRINT_ATx(%PC),%d1
		muls.w    %d1,%d0
		lea.l     PARAM_PRINT_REAL_ATx(%PC),%a0
		move.w    %d0,(%a0)
		
		|PARAM_PRINT_REAL_ATy = PARAM_PRINT_ATy*PARAM_FONT_DIVy;
		clr.w     %d0
		move.b    PARAM_FONT_DIVy(%PC),%d0
		move.w    PARAM_PRINT_ATy(%PC),%d1
		muls.w    %d1,%d0
		lea.l     PARAM_PRINT_REAL_ATy(%PC),%a0
		move.w    %d0,(%a0)
		
		TokensExec_EndFunc
		rts

|=====|
|PRINT|
|=====|
_ExecCmd_Print_integer:
		move.l    (%a0),-(%SP)
		pea.l     printf_ld(%PC)
		jbsr      printf
		addq.l    #8,%SP
		jbra      _ExecCmd_Print_next_continue
		
_ExecCmd_Print_float:
		move.w    8(%a0),-(%SP)
		move.l    4(%a0),-(%SP)
		move.l    (%a0),-(%SP)
		pea.l     printf_f(%PC)
		jbsr      printf
		lea.l     14(%SP),%SP
		jbra      _ExecCmd_Print_next_continue
		
_ExecCmd_Print_bool:
		move.b    (%a0),%d0				|Force le flottant  tre sur 16 Bits signs
		ext.w     %d0
		move.w    %d0,-(%SP)
		pea.l     printf_d(%PC)
		jbsr      printf
		addq.l    #6,%SP
		jbra      _ExecCmd_Print_next_continue
		
_ExecCmd_Print_string:
		pea.l     (%a0)
		pea.l     printf_s(%PC)
		jbsr      printf
		addq.l    #8,%SP
		jbra      _ExecCmd_Print_next_continue
		
_ExecCmd_Print_apost:
		pea.l     printf_space(%PC)
		jbsr      printf
		addq.l    #4,%SP
		jbra      _ExecCmd_Print_continue
		
_ExecCmd_Print_eofline:
		pea.l     printf_eofline(%PC)
		jbsr      printf
		addq.l    #4,%SP
		jbra      _ExecCmd_Print_continue

_ExecCmd_Print_ParamAT:
		lea.l     PARAM_PRINT_AT(%PC),%a0		|Place curseur de texte aux coordonnes spcifies par AT
		clr.w     (%a0)			
		move.w    PARAM_PRINT_REAL_ATy(%PC),-(%SP)
		move.w    PARAM_PRINT_REAL_ATx(%PC),-(%SP)
		ROM_CALL  MoveTo
		addq.l    #4,%SP
		jbra      _ExecCmd_Print_continue_in_start

ExecCmd_Print:
		jbsr      TokensExec_CNumArg
		
		move.w    PARAM_PRINT_AT(%PC),%d0		|Vrifie si la commande AT a t appelle soit PRINT AT...
		|tst.w     %d0
		jbne      _ExecCmd_Print_ParamAT
_ExecCmd_Print_continue_in_start:		
		movea.l   ptrEnd_ES(%PC),%a5			|Place la pile au dbut de la premire donnes
		lea.l     -12(%a5),%a5
		dbf       %d6,_ExecCmd_Print_loop
_ExecCmd_Print_eofline2:		
		pea.l     printf_eofline(%PC)
		jsr       printf
		addq.l    #4,%SP
		jbra      TokensExec_EndTokenCmd
		
_ExecCmd_Print_loop:
		move.b    (%a5),%d0				|Oprande		
		move.b    1(%a5),%d1				|Type
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		cmpi.b    #OPRD_POINT_VIRGULE,%d0		|Continue pour point virgule
		jbeq      _ExecCmd_Print_continue
		cmpi.b    #OPRD_APOST,%d0
		jbeq      _ExecCmd_Print_apost
		
		|Affichage donnes
		movea.l   4(%a5),%a0				|Donnes
		
		cmpi.b    #TYPE_INTEGER,%d1
		jbeq      _ExecCmd_Print_integer
		cmpi.b    #TYPE_FLOAT,%d1
		jbeq      _ExecCmd_Print_float
		cmpi.b    #TYPE_BOOL,%d1
		jbeq      _ExecCmd_Print_bool
		cmpi.b    #TYPE_STRING,%d1
		jbeq      _ExecCmd_Print_string

_ExecCmd_Print_next_continue:
		|Saut de ligne
		tst.l     %d6
		jbeq      _ExecCmd_Print_eofline2
		move.b    -12(%a5),%d0				|Oprande suivante
		cmpi.b    #OPRD_POINT_VIRGULE,%d0
		jbeq      _ExecCmd_Print_continue
		cmpi.b    #OPRD_APOST,%d0
		jbne      _ExecCmd_Print_eofline
		    
_ExecCmd_Print_continue:
		lea.l     -12(%a5),%a5				|Donnes suivante
		dbf       %d6,_ExecCmd_Print_loop	
		jbra      TokensExec_EndTokenCmd

|===|
|DIM|
|===|
_ExecCmd_Dim_block_integer:
		moveq.l   #SIZE_INTEGER,%d7
		jbra      _ExecCmd_Dim_loop_continue

_ExecCmd_Dim_block_float:
		moveq.l   #SIZE_FLOAT,%d7
		jbra      _ExecCmd_Dim_loop_continue
		
_ExecCmd_Dim_block_bool:
		moveq.l   #SIZE_BOOL,%d7
		jbra      _ExecCmd_Dim_loop_continue
		
ExecCmd_Dim:
		jbsr      TokensExec_CNumArg
		tst.w     %d6					|Pas d'arguments
		jbeq      _ERROR_few_arguments
		dbf       %d6,_ExecCmd_Dim_loop
_ExecCmd_Dim_loop:
		move.b    (%a5)+,%d0				|Operande
		cmpi.b    #OPRD_VARTABLE,%d0
		jbeq      _ERROR_defined_vartable
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d0
		jbne      _ERROR_incorrect_arg
		
		move.b    (%a5)+,%d0				|Type
		cmpi.b    #TYPE_INTEGER,%d0
		jbeq      _ExecCmd_Dim_block_integer
		cmpi.b    #TYPE_FLOAT,%d0
		jbeq      _ExecCmd_Dim_block_float
		cmpi.b    #TYPE_BOOL,%d0
		jbeq      _ExecCmd_Dim_block_bool
		moveq.l   #SIZE_DESCRIPTOR,%d7
_ExecCmd_Dim_loop_continue:
		moveq.l   #0,%d4				|Efface %d4
		move.w    (%a5)+,%d4				|ndim
		movea.l   (%a5)+,%a2				|Dimensions
		movea.l   %a2,%a3
		moveq.l   #1,%d3				|Total Dim
		moveq.l   #0,%d5
		move.w    %d4,%d5				|Boucle FOR 0  ndim
		dbf       %d5,_ExecCmd_Dim_loop_totaldim
_ExecCmd_Dim_loop_totaldim:
		mulu.w    (%a2)+,%d3				|total_dim *= dimension n
		dbf       %d5,_ExecCmd_Dim_loop_totaldim   
_ExecCmd_Dim_loop_totaldim_end:
		tst.w     %d3					|Pour tableau commence  index 0
		jbeq      _ERROR_tbl_zerodim
		move.w    %d3,%d5				|Sauvegarde Total Dim
		mulu.w    %d7,%d3				|BlockSize*Total Dim
		move.w    %d4,%d2
		add.w     %d2,%d2				|ndim*2
		add.w     %d2,%d3				|ndim+Total Dim
		move.l    %d3,-(%SP)
		ROM_CALL  malloc
		addq.l    #4,%SP
		move.l    %a0,%d0
		|tst.l     %d0					|No enough memory
		jbeq      _ERROR_no_enough_memory
		movea.l   (%a5)+,%a0				|Adresse descripteur
		movea.l   %d0,%a2				|Sauvegarde adresse
		move.l    %d0,(%a0)+				|Zone mmoire
		move.w    %d4,(%a0)				|Nombre de dimension
		
		|Copie les dimensions
		dbf       %d4,_ExecCmd_Dim_loop_copydim
_ExecCmd_Dim_loop_copydim:		
		move.w    (%a3)+,(%a2)+
		dbf       %d4,_ExecCmd_Dim_loop_copydim
		|Si chane de caractres
		cmpi.w    #SIZE_DESCRIPTOR,%d7
		jbeq      _ExecCmd_Dim_loop_clear_string
		cmpi.w    #SIZE_BOOL,%d7
		jbeq      _ExecCmd_Dim_loop_clear_bool
		
		|Espace vierge pour les donnes numriques
		dbf       %d5,_ExecCmd_Dim_loop_clear_numbers
_ExecCmd_Dim_loop_clear_numbers:
		clr.w     (%a2)+
		dbf       %d5,_ExecCmd_Dim_loop_clear_numbers
_ExecCmd_Dim_loop_copydim_end:
		dbf       %d6,_ExecCmd_Dim_loop
		jbra      TokensExec_EndTokenCmd
		
		|Initialise les chanes de caractres		
_ExecCmd_Dim_loop_clear_string:
		move.w    %d5,%d0
		movea.l   %a2,%a0
		jbsr      TokensExec_InitEmptyString
		dbf       %d6,_ExecCmd_Dim_loop
		jbra      TokensExec_EndTokenCmd
		
		|Efface octet par octet (boolens)
_ExecCmd_Dim_loop_clear_bool:
		dbf       %d5,_ExecCmd_Dim_loop_clear_numbers_bool
_ExecCmd_Dim_loop_clear_numbers_bool:
		clr.b     (%a2)+
		dbf       %d5,_ExecCmd_Dim_loop_clear_numbers_bool
		jbra      TokensExec_EndTokenCmd		


|===|
|CLS|
|===|		
ExecCmd_Cls:
		jbsr      clrscr
		jbra      TokensExec_EndTokenCmd

|======|
|GETKEY|
|======|		
ExecFnc_Getkey:
		jbsr      TokensExec_NumArg
		jbsr      _kb_getkey
		jbra      TokensExec_AddResult_Func_Integer

|===|
|ABS|
|===|
_ExecFnc_Abs_integer:
		move.l    (%a0),%d0
		jbpl      TokensExec_AddResult_Func_Integer
		neg.l     %d0
		jbra      TokensExec_AddResult_Func_Integer
		
_ExecFnc_Abs_float:
		|Empile number
		move.w    8(%a0),-(%SP)				|Empile fin flottant
		move.l    4(%a0),-(%SP)				|Empile milieu flottant
		move.l    (%a0),-(%SP)				|Empile dbut flottant
		move.w    #fabs*4,-(%SP)			|Wrapper
		jbsr      __BC
		lea.l     12(%SP),%SP
		jbra      TokensExec_AddResult_Func_Float
		
ExecFnc_Abs:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		move.w    %d6,%a3				|Sauvegarde nombre d'arguments
		
		TokensExec_SimpleType TRUE, TRUE, FALSE, FALSE, #TYPE_INTEGER
		tst.w     %d7
		jbeq      _Exec_exit
		move.w    %a3,%d6				|Restaure nombre d'arguments
		
		move.b    1(%a5),%d0				|Type number
		movea.l   4(%a5),%a0				|Number
		cmpi.b    #TYPE_INTEGER,%d0
		jbeq      _ExecFnc_Abs_integer
		jbra      _ExecFnc_Abs_float

|===|
|ADD|
|===|
_ExecCmd_Add_integer:
		move.l    (%a1),%d0				|Number 1
		add.l     %d0,(%a2)
		jbra      TokensExec_EndTokenCmd     
		
_ExecCmd_Add_float:
		|Empile number 1
		move.w    8(%a1),-(%SP)				|Empile fin flottant
		move.l    4(%a1),-(%SP)				|Empile milieu flottant
		move.l    (%a1),-(%SP)				|Empile dbut flottant
		|Empile number 2
		move.w    8(%a2),-(%SP)				|Empile fin flottant
		move.l    4(%a2),-(%SP)				|Empile milieu flottant
		move.l    (%a2),-(%SP)				|Empile dbut flottant
		move.w    #fadd*4,-(%SP)			|Wrapper
		jbsr      __BC
		lea.l     22(%SP),%SP
		move.l    %d0,(%a2)+				|Empile 4 octets dbut flottant
		move.l    %d1,(%a2)+				|Empile 4 octets suivant flottant
		move.w    %d2,(%a2)				|Empile 2 octets fin flottant
		jbra      TokensExec_EndTokenCmd
		
ExecCmd_Add:
		TokensExec_Cmd_CheckArg		#2
		tst.w     %d7
		jbeq      _Exec_exit 

		move.b    12(%a5),%d0				|Oprande number 2
		move.b    13(%a5),%d1				|Type number 2
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d0
		jbeq      _ERROR_undef_vartable
		cmpi.b    #OPRD_VAR,%d0
		jbeq	  _ExecCmd_Add_continue
		cmpi.b    #OPRD_VARTABLE,%d0
		jbne      _ERROR_incorrect_arg
_ExecCmd_Add_continue:
		cmpi.b    #TYPE_BOOL,%d1
		jbeq      _ERROR_incorrect_arg
		cmpi.b    #TYPE_STRING,%d1
		jbeq      _ERROR_incorrect_arg

		moveq.l   #TRUE,%d0				|Flottant
		moveq.l   #TRUE,%d1				|Integer
		moveq.l   #FALSE,%d2				|Boolean
		moveq.l   #FALSE,%d3				|String
		moveq.l   #TYPE_INTEGER,%d4			|Optimized type
		lea.l     12(%a5),%a2				|Number 2
		movea.l   %a5,%a3				|Number 1
		moveq.l   #0,%d7
		jbsr      TokensExec_ConvertTwoType
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number 1
		movea.l   4(%a5),%a1				|Number 1
		movea.l   16(%a5),%a2				|Number 2
		
		cmpi.b    #TYPE_INTEGER,%d0
		jbeq      _ExecCmd_Add_integer
		jbra	  _ExecCmd_Add_float
		
|===|
|ATN|
|===|		
ExecFnc_Atn:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_FLOAT,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		move.w    8(%a0),-(%SP)				|Empile fin flottant
		move.l    4(%a0),-(%SP)				|Empile milieu flottant
		move.l    (%a0),-(%SP)				|Empile dbut flottant
		move.w    #atan*4,-(%SP)			|Wrapper
		jbsr      __BC
		lea.l     12(%SP),%SP
		jbra      TokensExec_AddResult_Func_Float

|===|
|ATN|
|===|
_ExecCmd_Clr_del_vartable_string:
		movea.l   8(%a5),%a3
		move.w    4(%a3),%d0				|Nombre de dimensions
		movea.l   (%a3),%a3				|Zone de decripteurs
		jbsr      TokensExec_DeleteTabString
		jbra      _ExecCmd_Clr_loop_delete_vartable
		

_ExecCmd_Clr_del_var_float:
		clr.l     (%a0)+
		clr.l     (%a0)+
		clr.w     (%a0)
		jbra      _ExecCmd_Clr_loop_next
		
_ExecCmd_Clr_del_var_integer:
		clr.l     (%a0)
		jbra      _ExecCmd_Clr_loop_next

_ExecCmd_Clr_del_var_bool:
		clr.b     (%a0)
		jbra      _ExecCmd_Clr_loop_next
		
_ExecCmd_Clr_del_var_string:
		movea.l   8(%a5),%a2
		jbsr      TokensExec_DeleteSimpleString
		jbra      _ExecCmd_Clr_loop_next		

_ExecCmd_Clr_del_var:
		movea.l   4(%a5),%a0				|Donnes
		cmpi.b    #TYPE_FLOAT,%d1
		jbeq      _ExecCmd_Clr_del_var_float
		cmpi.b    #TYPE_INTEGER,%d1
		jbeq      _ExecCmd_Clr_del_var_integer
		cmpi.b    #TYPE_BOOL,%d1
		jbeq      _ExecCmd_Clr_del_var_bool
		jbra      _ExecCmd_Clr_del_var_string
		
ExecCmd_Clr:
		jbsr      TokensExec_CNumArg
		tst.w     %d6
		jbeq      _ERROR_few_arguments
				
		movea.l   ptrEnd_ES(%PC),%a5			|Place la pile au dbut de la premire donnes
		lea.l     -12(%a5),%a5
		dbf       %d6,_ExecCmd_Clr_loop
_ExecCmd_Clr_loop:
		|Tableau indfini
		move.b    (%a5),%d0
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d0
		jbeq      _ERROR_undef_vartable
		
		|Dffrent d'une variables ou d'un tableau
		cmpi.b    #OPRD_EMPTY_VARTABLE,%d0
		jbeq      _ExecCmd_Clr_loop_continue
		cmpi.b    #OPRD_VARTABLE,%d0
		jbeq      _ExecCmd_Clr_loop_continue
		cmpi.b    #OPRD_VAR,%d0
		jbne      _ERROR_incorrect_arg
		
_ExecCmd_Clr_loop_continue:
		move.b    1(%a5),%d1				|Type
		
		|Variables
		cmpi.b    #OPRD_VAR,%d0
		jbeq      _ExecCmd_Clr_del_var
		
		|Donne d'un tableau
		cmpi.b    #OPRD_VARTABLE,%d0
		jbeq      _ExecCmd_Clr_del_var
		
		|Tableaux
		cmpi.b    #TYPE_STRING,%d1
		jbeq      _ExecCmd_Clr_del_vartable_string
_ExecCmd_Clr_loop_delete_vartable:
		movea.l   8(%a5),%a3				|Descripteur
		move.l    (%a3),-(%SP)				|Zone mmoire donnes tableau
		ROM_CALL  free
		addq.l    #4,%SP
		clr.l     (%a3)+				|Zone mmoire NULL
		clr.w     (%a3)					|Nombre de dimensions = 0
_ExecCmd_Clr_loop_next:		
		lea.l     -12(%a5),%a5				|Donnes suivante
		dbf       %d6,_ExecCmd_Clr_loop
		jbra      TokensExec_EndTokenCmd

|===|
|COS|
|===|		
ExecFnc_Cos:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_FLOAT,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		move.w    8(%a0),-(%SP)				|Empile fin flottant
		move.l    4(%a0),-(%SP)				|Empile milieu flottant
		move.l    (%a0),-(%SP)				|Empile dbut flottant
		move.w    #cos*4,-(%SP)				|Wrapper
		jbsr      __BC
		lea.l     12(%SP),%SP
		jbra      TokensExec_AddResult_Func_Float
		
|===|
|DEC|
|===|
_ExecCmd_Dec_integer:
		subq.l    #1,(%a2)
		jbra      TokensExec_EndTokenCmd

_ExecCmd_Dec_float:
		|Empile number 1
		clr.w     -(%SP)				|Empile fin flottant
		clr.l     -(%SP)				|Empile milieu flottant
		move.l    #0x40001000,-(%SP)			|Empile dbut flottant
		|Empile number 2
		move.w    8(%a2),-(%SP)				|Empile fin flottant
		move.l    4(%a2),-(%SP)				|Empile milieu flottant
		move.l    (%a2),-(%SP)				|Empile dbut flottant
		move.w    #fsub*4,-(%SP)			|Wrapper
		jbsr      __BC
		lea.l     22(%SP),%SP
		move.l    %d0,(%a2)+				|Empile 4 octets dbut flottant
		move.l    %d1,(%a2)+				|Empile 4 octets suivant flottant
		move.w    %d2,(%a2)				|Empile 2 octets fin flottant
		jbra      TokensExec_EndTokenCmd
		
ExecCmd_Dec:
		TokensExec_Cmd_CheckArg		#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    (%a5),%d0				|Oprande number 1
		move.b    1(%a5),%d1				|Type number 1
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d0
		jbeq      _ERROR_undef_vartable
		cmpi.b    #OPRD_VAR,%d0
		jbeq	  _ExecCmd_Dec_continue
		cmpi.b    #OPRD_VARTABLE,%d0
		jbne      _ERROR_incorrect_arg
_ExecCmd_Dec_continue:
		cmpi.b    #TYPE_BOOL,%d1
		jbeq      _ERROR_incorrect_arg
		cmpi.b    #TYPE_STRING,%d1
		jbeq      _ERROR_incorrect_arg
		
		movea.l   4(%a5),%a2				|Number 1
		
		cmpi.b    #TYPE_INTEGER,%d1
		jbeq      _ExecCmd_Dec_integer
		jbra      _ExecCmd_Dec_float
		
|===|
|DIV|
|===|
_ExecCmd_Div_integer:
		move.l    (%a1),%d0				|Number 1
		|tst.l     %d0
		jbeq      _ERROR_divide_by_zero
		
		move.l    %d0,-(%SP)				|Number 1
		move.l    (%a2),-(%SP)				|Number 2
		jbsr      __divsi3
		addq.l    #8,%SP
		move.l    %d0,(%a2)
		jbra      TokensExec_EndTokenCmd     
		
_ExecCmd_Div_float:
		move.w    8(%a1),%d0				|Division par zro? (Comparaison imparfaite!)
		move.l    4(%a1),%d1
		move.l    (%a1),%d2
		tst.w     %d0
		jbne      _ExecCmd_Div_float_next
		tst.l     %d1
		jbne      _ExecCmd_Div_float_next
		tst.w     %d2
		jbne      _ExecCmd_Div_float_next
		jbra	  _ERROR_divide_by_zero
		
_ExecCmd_Div_float_next:
		|Empile number 1
		move.w    8(%a1),-(%SP)				|Empile fin flottant
		move.l    4(%a1),-(%SP)				|Empile milieu flottant
		move.l    (%a1),-(%SP)				|Empile dbut flottant
		|Empile number 2
		move.w    8(%a2),-(%SP)				|Empile fin flottant
		move.l    4(%a2),-(%SP)				|Empile milieu flottant
		move.l    (%a2),-(%SP)				|Empile dbut flottant
		move.w    #fdiv*4,-(%SP)			|Wrapper
		jbsr      __BC
		lea.l     22(%SP),%SP
		move.l    %d0,(%a2)+				|Empile 4 octets dbut flottant
		move.l    %d1,(%a2)+				|Empile 4 octets suivant flottant
		move.w    %d2,(%a2)				|Empile 2 octets fin flottant
		jbra      TokensExec_EndTokenCmd
		
ExecCmd_Div:
		TokensExec_Cmd_CheckArg		#2
		tst.w     %d7
		jbeq      _Exec_exit 

		move.b    12(%a5),%d0				|Oprande number 2
		move.b    13(%a5),%d1				|Type number 2
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d0
		jbeq      _ERROR_undef_vartable
		cmpi.b    #OPRD_VAR,%d0
		jbeq	  _ExecCmd_Div_continue
		cmpi.b    #OPRD_VARTABLE,%d0
		jbne      _ERROR_incorrect_arg
_ExecCmd_Div_continue:
		cmpi.b    #TYPE_BOOL,%d1
		jbeq      _ERROR_incorrect_arg
		cmpi.b    #TYPE_STRING,%d1
		jbeq      _ERROR_incorrect_arg

		moveq.l   #TRUE,%d0				|Flottant
		moveq.l   #TRUE,%d1				|Integer
		moveq.l   #FALSE,%d2				|Boolean
		moveq.l   #FALSE,%d3				|String
		moveq.l   #TYPE_INTEGER,%d4			|Optimized type
		lea.l     12(%a5),%a2				|Number 2
		movea.l   %a5,%a3				|Number 1
		moveq.l   #0,%d7
		jbsr      TokensExec_ConvertTwoType
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number 1
		movea.l   4(%a5),%a1				|Number 1
		movea.l   16(%a5),%a2				|Number 2
		
		cmpi.b    #TYPE_INTEGER,%d0
		jbeq      _ExecCmd_Div_integer
		jbra	  _ExecCmd_Div_float

|====|
|EVEN|
|====|		
ExecFnc_Even:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		move.l    (%a0),%d0
		andi.l    #1,%d0
		subq.w    #1,%d0
		jbra      TokensExec_AddResult_Func_Bool
		
|===|
|EXP|
|===|		
ExecFnc_Exp:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_FLOAT,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		move.w    8(%a0),-(%SP)				|Empile fin flottant
		move.l    4(%a0),-(%SP)				|Empile milieu flottant
		move.l    (%a0),-(%SP)				|Empile dbut flottant
		move.w    #exp*4,-(%SP)				|Wrapper
		jbsr      __BC
		lea.l     12(%SP),%SP
		jbra      TokensExec_AddResult_Func_Float
		
|===|
|FIX|
|===|
ExecFnc_Fix:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0
		move.l    (%a0),%d0
		jbra      TokensExec_AddResult_Func_Integer

|====|
|FRAC|
|====|		
ExecFnc_Frac:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_FLOAT,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0		
		move.w    8(%a0),%d5				|Empile fin flottant
		move.l    4(%a0),%d4				|Empile milieu flottant
		move.l    (%a0),%d3				|Empile dbut flottant
		move.w    %d5,-(%SP)
		move.l    %d4,-(%SP)
		move.l    %d3,-(%SP)
		move.w    #floor*4,-(%SP)			|Wrapper
		jbsr      __BC		
		move.w    %d2,-(%SP)
		move.l    %d1,-(%SP)
		move.l    %d0,-(%SP)
		move.w    %d5,-(%SP)				|Empile fin flottant
		move.l    %d4,-(%SP)				|Empile milieu flottant
		move.l    %d3,-(%SP)				|Empile dbut flottant
		move.w    #fsub*4,-(%SP)			|Wrapper
		jbsr      __BC
		lea       34(%SP),%SP
		jbra      TokensExec_AddResult_Func_Float
		
|===|
|INC|
|===|
_ExecCmd_Inc_integer:
		addq.l    #1,(%a2)
		jbra      TokensExec_EndTokenCmd

_ExecCmd_Inc_float:
		|Empile number 1
		clr.w     -(%SP)				|Empile fin flottant
		clr.l     -(%SP)				|Empile milieu flottant
		move.l    #0x40001000,-(%SP)			|Empile dbut flottant
		|Empile number 2
		move.w    8(%a2),-(%SP)				|Empile fin flottant
		move.l    4(%a2),-(%SP)				|Empile milieu flottant
		move.l    (%a2),-(%SP)				|Empile dbut flottant
		move.w    #fadd*4,-(%SP)			|Wrapper
		jbsr      __BC
		lea.l     22(%SP),%SP
		move.l    %d0,(%a2)+				|Empile 4 octets dbut flottant
		move.l    %d1,(%a2)+				|Empile 4 octets suivant flottant
		move.w    %d2,(%a2)				|Empile 2 octets fin flottant
		jbra      TokensExec_EndTokenCmd
		
ExecCmd_Inc:
		TokensExec_Cmd_CheckArg		#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    (%a5),%d0				|Oprande number 1
		move.b    1(%a5),%d1				|Type number 1
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d0
		jbeq      _ERROR_undef_vartable
		cmpi.b    #OPRD_VAR,%d0
		jbeq	  _ExecCmd_Inc_continue
		cmpi.b    #OPRD_VARTABLE,%d0
		jbne      _ERROR_incorrect_arg
_ExecCmd_Inc_continue:
		cmpi.b    #TYPE_BOOL,%d1
		jbeq      _ERROR_incorrect_arg
		cmpi.b    #TYPE_STRING,%d1
		jbeq      _ERROR_incorrect_arg
		
		movea.l   4(%a5),%a2				|Number 1
		
		cmpi.b    #TYPE_INTEGER,%d1
		jbeq      _ExecCmd_Inc_integer
		jbra      _ExecCmd_Inc_float

|===|
|LOG|
|===|								
ExecFnc_Log:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_FLOAT,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a2				|Number
		move.w    #0x4000,-(%SP)			|Place flottant = 0 dans SP
		clr.l     -(%SP)
		clr.l     -(%SP)	
		move.w    8(%a2),-(%SP)				|Empile fin flottant
		move.l    4(%a2),-(%SP)				|Empile milieu flottant
		move.l    (%a2),-(%SP)				|Empile dbut flottant
		ROM_CALL  fcmp
		lea.l     20(%SP),%SP
		tst.l     %d0
		jble      _ERROR_log
		
_ExecFnc_Log_float_next:	
		move.w    8(%a2),-(%SP)				|Empile fin flottant
		move.l    4(%a2),-(%SP)				|Empile milieu flottant
		move.l    (%a2),-(%SP)				|Empile dbut flottant
		move.w    #log*4,-(%SP)				|Wrapper
		jbsr      __BC
		lea.l     12(%SP),%SP
		jbra      TokensExec_AddResult_Func_Float
		
|=====|
|LOG10|
|=====|								
ExecFnc_Log10:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_FLOAT,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a2				|Number
		move.w    #0x4000,-(%SP)			|Place flottant = 0 dans SP
		clr.l     -(%SP)
		clr.l     -(%SP)	
		move.w    8(%a2),-(%SP)				|Empile fin flottant
		move.l    4(%a2),-(%SP)				|Empile milieu flottant
		move.l    (%a2),-(%SP)				|Empile dbut flottant
		ROM_CALL  fcmp
		lea.l     20(%SP),%SP
		tst.l     %d0
		jble      _ERROR_log
		
_ExecFnc_Log10_float_next:	
		move.w    8(%a2),-(%SP)				|Empile fin flottant
		move.l    4(%a2),-(%SP)				|Empile milieu flottant
		move.l    (%a2),-(%SP)				|Empile dbut flottant
		move.w    #log10*4,-(%SP)			|Wrapper
		jbsr      __BC
		lea.l     12(%SP),%SP
		jbra      TokensExec_AddResult_Func_Float
		
|===|
|MUL|
|===|
_ExecCmd_Mul_integer:
		move.l    (%a1),-(%SP)				|Number 1
		move.l    (%a2),-(%SP)				|Number 2
		jbsr      __mulsi3
		addq.l    #8,%SP
		move.l    %d0,(%a2)
		jbra      TokensExec_EndTokenCmd     
		
_ExecCmd_Mul_float:
		|Empile number 1
		move.w    8(%a1),-(%SP)				|Empile fin flottant
		move.l    4(%a1),-(%SP)				|Empile milieu flottant
		move.l    (%a1),-(%SP)				|Empile dbut flottant
		|Empile number 2
		move.w    8(%a2),-(%SP)				|Empile fin flottant
		move.l    4(%a2),-(%SP)				|Empile milieu flottant
		move.l    (%a2),-(%SP)				|Empile dbut flottant
		move.w    #fmul*4,-(%SP)			|Wrapper
		jbsr      __BC
		lea.l     22(%SP),%SP
		move.l    %d0,(%a2)+				|Empile 4 octets dbut flottant
		move.l    %d1,(%a2)+				|Empile 4 octets suivant flottant
		move.w    %d2,(%a2)				|Empile 2 octets fin flottant
		jbra      TokensExec_EndTokenCmd
		
ExecCmd_Mul:
		TokensExec_Cmd_CheckArg		#2
		tst.w     %d7
		jbeq      _Exec_exit 

		move.b    12(%a5),%d0				|Oprande number 2
		move.b    13(%a5),%d1				|Type number 2
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d0
		jbeq      _ERROR_undef_vartable
		cmpi.b    #OPRD_VAR,%d0
		jbeq	  _ExecCmd_Mul_continue
		cmpi.b    #OPRD_VARTABLE,%d0
		jbne      _ERROR_incorrect_arg
_ExecCmd_Mul_continue:
		cmpi.b    #TYPE_BOOL,%d1
		jbeq      _ERROR_incorrect_arg
		cmpi.b    #TYPE_STRING,%d1
		jbeq      _ERROR_incorrect_arg

		moveq.l   #TRUE,%d0				|Flottant
		moveq.l   #TRUE,%d1				|Integer
		moveq.l   #FALSE,%d2				|Boolean
		moveq.l   #FALSE,%d3				|String
		moveq.l   #TYPE_INTEGER,%d4			|Optimized type
		lea.l     12(%a5),%a2				|Number 2
		movea.l   %a5,%a3				|Number 1
		moveq.l   #0,%d7
		jbsr      TokensExec_ConvertTwoType
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number 1
		movea.l   4(%a5),%a1				|Number 1
		movea.l   16(%a5),%a2				|Number 2
		
		cmpi.b    #TYPE_INTEGER,%d0
		jbeq      _ExecCmd_Mul_integer
		jbra	  _ExecCmd_Mul_float
		
|===|
|ODD|
|===|		
ExecFnc_Odd:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		move.l    (%a0),%d0
		andi.l    #1,%d0
		neg.w     %d0
		jbra      TokensExec_AddResult_Func_Bool

|===|
|SGN|
|===|
_ExecFnc_Sgn_float:
		move.w    8(%a0),%d0				|Division par zro? (Comparaison imparfaite!)
		move.l    4(%a0),%d1
		move.l    (%a0),%d2
		tst.w     %d0
		jbne      _ExecFnc_Sgn_float_next
		tst.l     %d1
		jbne      _ExecFnc_Sgn_float_next
		tst.w     %d2
		jbne      _ExecFnc_Sgn_float_next
		moveq.l   #0,%d0
		jbra      TokensExec_AddResult_Func_Integer
		
_ExecFnc_Sgn_float_next:
		move.w    #0x4000,-(%SP)			|Place flottant = 0 dans SP
		clr.l     -(%SP)
		clr.l     -(%SP)	
		move.w    %d0,-(%SP)				|Empile fin flottant
		move.l    %d1,-(%SP)				|Empile milieu flottant
		move.l    %d2,-(%SP)				|Empile dbut flottant
		ROM_CALL  fcmp
		lea.l     20(%SP),%SP
		tst.l     %d0
		jbmi      _ExecFnc_Sgn_minus
		moveq.l   #1,%d0
		jbra      TokensExec_AddResult_Func_Integer						

_ExecFnc_Sgn_integer_zero:
		moveq.l   #0,%d0
		jbra      TokensExec_AddResult_Func_Integer
		
_ExecFnc_Sgn_minus:
		moveq.l   #-1,%d0
		jbra      TokensExec_AddResult_Func_Integer

_ExecFnc_Sgn_integer:
		move.l    (%a0),%d0
		tst.l     (%a0)
		jbeq      _ExecFnc_Sgn_integer_zero
		jbmi      _ExecFnc_Sgn_minus
		moveq.l   #1,%d0
		jbra      TokensExec_AddResult_Func_Integer
				
ExecFnc_Sgn:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.w    %d6,%a3				|Sauvegarde nombre d'arguments
		
		TokensExec_SimpleType TRUE, TRUE, FALSE, FALSE, #TYPE_INTEGER
		tst.w     %d7
		jbeq      _Exec_exit
		move.w    %a3,%d6				|Restaure nombre d'arguments
		
		move.b    1(%a5),%d0				|Type number
		movea.l   4(%a5),%a0				|Number
		cmpi.b    #TYPE_INTEGER,%d0
		jbeq      _ExecFnc_Sgn_integer
		jbra      _ExecFnc_Sgn_float

|===|
|SIN|
|===|
ExecFnc_Sin:		
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_FLOAT,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		move.w    8(%a0),-(%SP)				|Empile fin flottant
		move.l    4(%a0),-(%SP)				|Empile milieu flottant
		move.l    (%a0),-(%SP)				|Empile dbut flottant
		move.w    #sin*4,-(%SP)				|Wrapper
		jbsr      __BC
		lea.l     12(%SP),%SP
		jbra      TokensExec_AddResult_Func_Float
		
|===|
|SQR|
|===|								
ExecFnc_Sqr:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_FLOAT,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a2				|Number
		move.w    #0x4000,-(%SP)			|Place flottant = 0 dans SP
		clr.l     -(%SP)
		clr.l     -(%SP)	
		move.w    8(%a2),-(%SP)				|Empile fin flottant
		move.l    4(%a2),-(%SP)				|Empile milieu flottant
		move.l    (%a2),-(%SP)				|Empile dbut flottant
		ROM_CALL  fcmp
		lea.l     20(%SP),%SP
		tst.l     %d0
		jbmi      _ERROR_square
		
_ExecFnc_Sqr_float_next:	
		move.w    8(%a2),-(%SP)				|Empile fin flottant
		move.l    4(%a2),-(%SP)				|Empile milieu flottant
		move.l    (%a2),-(%SP)				|Empile dbut flottant
		move.w    #sqrt*4,-(%SP)			|Wrapper
		jbsr      __BC
		lea.l     12(%SP),%SP
		jbra      TokensExec_AddResult_Func_Float
		
|===|
|TAN|
|===|		
ExecFnc_Tan:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_FLOAT,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		move.w    8(%a0),-(%SP)				|Empile fin flottant
		move.l    4(%a0),-(%SP)				|Empile milieu flottant
		move.l    (%a0),-(%SP)				|Empile dbut flottant
		move.w    #tan*4,-(%SP)				|Wrapper
		jbsr      __BC
		lea.l     12(%SP),%SP
		jbra      TokensExec_AddResult_Func_Float

|=====|
|ROUND|
|=====|
_ExecFnc_Round_plus:
		clr.w     -(%SP)				|Flottant = 0.5
		clr.l     -(%SP)
		move.l    #0x3FFF5000,-(%SP)
		move.w    %d5,-(%SP)
		move.l    %d4,-(%SP)
		move.l    %d3,-(%SP)
		move.w    #fadd*4,-(%SP)			|Wrapper
		jbsr      __BC
		move.w    %d2,-(%SP)
		move.l    %d1,-(%SP)
		move.l    %d0,-(%SP)
		ROM_CALL  trunc
		lea.l     32(%SP),%SP
		jbra      TokensExec_AddResult_Func_Integer
		        
_ExecFnc_Round_minus:
		move.w    %d5,-(%SP)
		move.l    %d4,-(%SP)
		move.l    %d3,-(%SP)
		clr.w     -(%SP)				|Flottant = 0.5
		clr.l     -(%SP)
		move.l    #0x3FFF5000,-(%SP)
		move.w    #fsub*4,-(%SP)			|Wrapper
		jbsr      __BC
		move.w    %d2,-(%SP)
		move.l    %d1,-(%SP)
		move.l    %d0,-(%SP)
		ROM_CALL  trunc
		lea.l     32(%SP),%SP
		neg.l     %d0
		jbra      TokensExec_AddResult_Func_Integer
		
ExecFnc_Round:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_FLOAT,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0
		move.w    8(%a0),%d5
		move.l    4(%a0),%d4
		move.l    (%a0),%d3
		move.w    #0x4000,-(%SP)			|Place flottant = 0 dans SP
		clr.l     -(%SP)
		clr.l     -(%SP)
		move.w    %d5,-(%SP)				|Empile fin flottant
		move.l    %d4,-(%SP)				|Empile milieu flottant
		move.l    %d3,-(%SP)				|Empile dbut flottant
		ROM_CALL  fcmp
		lea.l     20(%SP),%SP
		tst.l     %d0
		jbge      _ExecFnc_Round_plus
		jbra      _ExecFnc_Round_minus
		
|===|
|SUB|
|===|
_ExecCmd_Sub_integer:
		move.l    (%a1),%d0				|Number 1
		sub.l     %d0,(%a2)
		jbra      TokensExec_EndTokenCmd     
		
_ExecCmd_Sub_float:
		|Empile number 1
		move.w    8(%a1),-(%SP)				|Empile fin flottant
		move.l    4(%a1),-(%SP)				|Empile milieu flottant
		move.l    (%a1),-(%SP)				|Empile dbut flottant
		|Empile number 2
		move.w    8(%a2),-(%SP)				|Empile fin flottant
		move.l    4(%a2),-(%SP)				|Empile milieu flottant
		move.l    (%a2),-(%SP)				|Empile dbut flottant
		move.w    #fsub*4,-(%SP)			|Wrapper
		jbsr      __BC
		lea.l     22(%SP),%SP
		move.l    %d0,(%a2)+				|Empile 4 octets dbut flottant
		move.l    %d1,(%a2)+				|Empile 4 octets suivant flottant
		move.w    %d2,(%a2)				|Empile 2 octets fin flottant
		jbra      TokensExec_EndTokenCmd
		
ExecCmd_Sub:
		TokensExec_Cmd_CheckArg		#2
		tst.w     %d7
		jbeq      _Exec_exit 

		move.b    12(%a5),%d0				|Oprande number 2
		move.b    13(%a5),%d1				|Type number 2
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d0
		jbeq      _ERROR_undef_vartable
		cmpi.b    #OPRD_VAR,%d0
		jbeq	  _ExecCmd_Sub_continue
		cmpi.b    #OPRD_VARTABLE,%d0
		jbne      _ERROR_incorrect_arg
_ExecCmd_Sub_continue:
		cmpi.b    #TYPE_BOOL,%d1
		jbeq      _ERROR_incorrect_arg
		cmpi.b    #TYPE_STRING,%d1
		jbeq      _ERROR_incorrect_arg

		moveq.l   #TRUE,%d0				|Flottant
		moveq.l   #TRUE,%d1				|Integer
		moveq.l   #FALSE,%d2				|Boolean
		moveq.l   #FALSE,%d3				|String
		moveq.l   #TYPE_INTEGER,%d4			|Optimized type
		lea.l     12(%a5),%a2				|Number 2
		movea.l   %a5,%a3				|Number 1
		moveq.l   #0,%d7
		jbsr      TokensExec_ConvertTwoType
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number 1
		movea.l   4(%a5),%a1				|Number 1
		movea.l   16(%a5),%a2				|Number 2
		
		cmpi.b    #TYPE_INTEGER,%d0
		jbeq      _ExecCmd_Sub_integer
		jbra	  _ExecCmd_Sub_float

|===|
|ASC|
|===|		
ExecFnc_Asc:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    (%a5),%d0				|Oprande
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type
		cmpi.b    #TYPE_STRING,%d0
		jbne      _ERROR_types_incompatible
		
		movea.l   4(%a5),%a0
		moveq.l   #0,%d0
		move.b    (%a0),%d0
		jbra      TokensExec_AddResult_Func_Integer

|===|
|BIN|
|===|
_ExecFnc_Bin_zero:
		move.b    #'0',(%a0)+
		dbf       %d1,_ExecFnc_Bin_loop	
		rts
		
ExecFnc_Bin:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		move.l    (%a0),%d4
		move.l    %d4,%d0
		jbsr      Func_GetnBits
		move.l    %d0,%d1
		jbsr      TokensExec_AddResult_Func_String
		subq.l    #1,%d1
		
_ExecFnc_Bin_loop:
		moveq.l   #1,%d2
		lsl.l     %d1,%d2
		and.l     %d4,%d2
		jbeq      _ExecFnc_Bin_zero
		move.b    #'1',(%a0)+
		dbf       %d1,_ExecFnc_Bin_loop		
		rts

|===|
|HEX|
|===|		
ExecFnc_Hex:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		move.l    (%a0),%d4
		move.l    %d4,%d0
		moveq.l   #4,%d1
		jbsr      Func_GetnDigits
		move.l    %d0,%d1
		jbsr      TokensExec_AddResult_Func_String
		subq.l    #1,%d1
		lea.l     TableHexa(%PC),%a2
		
_ExecFnc_Hex_loop:
		move.l    %d1,%d0
		lsl.l     #2,%d0
		move.l    %d4,%d2
		lsr.l     %d0,%d2
		andi.l    #15,%d2
		lea.l     (%d2.w,%a2),%a1
		move.b    (%a1),(%a0)+
		dbf       %d1,_ExecFnc_Hex_loop		
		rts

|===|
|OCT|
|===|		
ExecFnc_Oct:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		move.l    (%a0),%d4
		move.l    %d4,%d0
		moveq.l   #3,%d1
		jbsr      Func_GetnDigits
		move.l    %d0,%d1
		jbsr      TokensExec_AddResult_Func_String
		subq.l    #1,%d1
		
_ExecFnc_Oct_loop:
		move.l    %d1,%d0
		mulu.w    #3,%d0
		move.l    %d4,%d2
		lsr.l     %d0,%d2
		andi.l    #7,%d2
		addi.b    #'0',%d2
		move.b    %d2,(%a0)+
		dbf       %d1,_ExecFnc_Oct_loop		
		rts

|===|
|CHR|
|===|		
ExecFnc_Chr:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a4				|Number
		moveq.l   #1,%d0
		jbsr      TokensExec_AddResult_Func_String
		move.b    3(%a4),(%a0)
		rts

|====|
|LEFT|
|====|
_ExecFnc_Left_nchar:
		move.b    1(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0
		move.w    2(%a0),%d4
		lea.l     12(%a5),%a2
		jbra      _ExecFnc_Left_continue
		
ExecFnc_Left:
		jbsr      TokensExec_NumArg
		cmpi.w    #2,%d6				|Trop d'arguments
		jbhi      _ERROR_too_arguments
		cmpi.w    #1,%d6				|Pas assez d'arguments
		jbcs      _ERROR_few_arguments
		
		movea.l   %a5,%a2
		moveq.l   #1,%d4
		cmpi.w    #2,%d6
		jbcc      _ExecFnc_Left_nchar
_ExecFnc_Left_continue:		
		move.b    (%a2),%d0				|Oprande
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a2),%d0				|Type
		cmpi.b    #TYPE_STRING,%d0
		jbne      _ERROR_types_incompatible

		move.w    2(%a2),%d0
		cmp.w     %d0,%d4
		jbls      _ExecFnc_Left_continue2
		move.w    %d0,%d4
_ExecFnc_Left_continue2:
		movea.l   4(%a2),%a4
		move.w    %d4,%d0
		jbsr      TokensExec_AddResult_Func_String
		move.w    %d4,%d0
		movea.l   %a0,%a1
		movea.l   %a4,%a0
		jbra      TokensExec_CopyString

|===|
|LEN|
|===|		
ExecFnc_Len:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    (%a5),%d0				|Oprande
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type
		cmpi.b    #TYPE_STRING,%d0
		jbne      _ERROR_types_incompatible
		
		moveq.l   #0,%d0
		move.w    2(%a5),%d0
		jbra      TokensExec_AddResult_Func_Integer

|===|
|MID|
|===|
_ExecFnc_Mid_size:
		move.b    1(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0
		move.w    2(%a0),%d4				|%d4 = Paramtre size
		lea.l     12(%a5),%a4				|Avance %a4 donne suivante
		jbra      _ExecFnc_Mid_continue
		
ExecFnc_Mid:
		jbsr      TokensExec_NumArg
		cmpi.w    #3,%d6				|Trop d'arguments
		jbhi      _ERROR_too_arguments
		cmpi.w    #2,%d6				|Pas assez d'arguments
		jbcs      _ERROR_few_arguments
		
		movea.l   %a5,%a4				|Pile dans %a4
		cmpi.w    #3,%d6				|Argument facultatif (size)
		jbeq      _ExecFnc_Mid_size
_ExecFnc_Mid_continue:
		move.b    1(%a4),%d0				|Pos
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a4,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    12(%a4),%d0				|Oprande
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    13(%a4),%d0				|Type
		cmpi.b    #TYPE_STRING,%d0
		jbne      _ERROR_types_incompatible
		
		movea.l   4(%a4),%a0
		move.w    2(%a0),%d3				|%d3 = Paramtre pos
		jbeq      _ExecFnc_Mid_continue2
		subi.w    #1,%d3				|%d3 = pos-1
_ExecFnc_Mid_continue2:
		cmpi.w    #3,%d6
		jbeq      _ExecFnc_Mid_continue3
		move.W    14(%a4),%d4				|%d4 = string size
		sub.w     %d3,%d4				|%d4 = string size-pos
_ExecFnc_Mid_continue3:
		move.w    14(%a4),%d0
		cmp.w     %d0,%d3
		jbcc      _ExecFnc_Mid_clear_len
		move.w    %d3,%d1
		add.w     %d4,%d1
		cmp.w     %d0,%d1
		jbcs      _ExecFnc_Mid_continue4
		sub.w     %d3,%d0
		move.w    %d0,%d4
_ExecFnc_Mid_continue4:
		move.w    %d4,%d0
		jbsr      TokensExec_AddResult_Func_String
		movea.l   %a0,%a1
		movea.l   16(%a4),%a0
		lea.l     (%d3.w,%a0),%a0
		move.w    %d4,%d0
		jbra      TokensExec_CopyString
		
_ExecFnc_Mid_clear_len:
		clr.w     %d4
		jbra      _ExecFnc_Mid_continue4

|=====|
|RIGHT|
|=====|		
_ExecFnc_Right_nchar:
		move.b    1(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0
		move.w    2(%a0),%d4
		lea.l     12(%a5),%a2
		jbra      _ExecFnc_Right_continue
		
ExecFnc_Right:
		jbsr      TokensExec_NumArg
		cmpi.w    #2,%d6				|Trop d'arguments
		jbhi      _ERROR_too_arguments
		cmpi.w    #1,%d6				|Pas assez d'arguments
		jbcs      _ERROR_few_arguments
		
		movea.l   %a5,%a2
		moveq.l   #1,%d4
		cmpi.w    #2,%d6
		jbcc      _ExecFnc_Right_nchar
_ExecFnc_Right_continue:		
		move.b    (%a2),%d0				|Oprande
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a2),%d0				|Type
		cmpi.b    #TYPE_STRING,%d0
		jbne      _ERROR_types_incompatible

		move.w    2(%a2),%d3
		cmp.w     %d3,%d4
		jbls      _ExecFnc_Right_continue2
		move.w    %d3,%d4
_ExecFnc_Right_continue2:
		movea.l   4(%a2),%a4
		move.w    %d4,%d0
		jbsr      TokensExec_AddResult_Func_String
		sub.w     %d4,%d3
		adda.w    %d3,%a4
		move.w    %d4,%d0
		movea.l   %a0,%a1
		movea.l   %a4,%a0
		jbra      TokensExec_CopyString
		
ExecFnc_Space:
		rts
		
ExecFnc_Str:
		rts
		
ExecFnc_String:
		rts
		
ExecFnc_Upper:
		rts
		
ExecFnc_Val:
		rts
		
ExecFnc_Arrayfill:
		rts

|====|
|LDIM|
|====|		
ExecFnc_Ldim:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    (%a5),%d0				|Oprande
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d0
		jbne      _ExecFnc_Ldim_next
		moveq.l   #0,%d0
		jbra       TokensExec_AddResult_Func_Integer      
_ExecFnc_Ldim_next:
		cmpi.b    #OPRD_EMPTY_VARTABLE,%d0
		jbne      _ERROR_incorrect_arg
		
		movea.l   %a5,%a2				|Zone pile ES
		jbsr      TokensExec_TotalDimVarTable
		jbra      TokensExec_AddResult_Func_Integer  
		
ExecCmd_End:
		rts

|===|
|FRE|
|===|		
ExecFnc_Fre:
		jbsr      TokensExec_NumArg
		
		ROM_CALL   HeapCompress
		ROM_CALL   HeapAvail
		jbra       TokensExec_AddResult_Func_Integer

|=====|
|PAUSE|
|=====|		
ExecCmd_Pause:
		TokensExec_Cmd_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		move.l    (%a0),%d0
		move.l    counter_time(%PC),%d1			|%d1 = counter_time
		lsl.l     #2,%d0
		add.l     %d1,%d0
_ExecCmd_Pause_loop:
		cmp.l     counter_time(%PC),%d0
		jbcc      _ExecCmd_Pause_loop
		jbra      TokensExec_EndTokenCmd
		
ExecCmd_Swap:
		rts

|===|
|MKI|
|===|		
ExecFnc_Mki:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a4				|Number
		moveq.l   #SIZE_INTEGER16,%d0
		jbsr      TokensExec_AddResult_Func_String
		move.w    2(%a4),(%a0)
		rts

|===|
|MKL|
|===|		
ExecFnc_Mkl:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a4				|Number
		moveq.l   #SIZE_INTEGER,%d0
		jbsr      TokensExec_AddResult_Func_String
		move.l    (%a4),(%a0)
		rts

|===|
|MKF|
|===|		
ExecFnc_Mkf:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_FLOAT,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a4				|Number
		moveq.l   #SIZE_FLOAT,%d0
		jbsr      TokensExec_AddResult_Func_String
		move.l    (%a4)+,(%a0)+
		move.l    (%a4)+,(%a0)+
		move.w    (%a4),(%a0)
		rts

|===|
|CVI|
|===|		
ExecFnc_Cvi:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    (%a5),%d0				|Oprande
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type
		cmpi.b    #TYPE_STRING,%d0
		jbne      _ERROR_types_incompatible
		
		movea.l   4(%a5),%a0
		moveq.l   #0,%d0
		move.w    (%a0),%d0
		jbra      TokensExec_AddResult_Func_Integer

|===|
|CVL|
|===|		
ExecFnc_Cvl:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    (%a5),%d0				|Oprande
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type
		cmpi.b    #TYPE_STRING,%d0
		jbne      _ERROR_types_incompatible
		
		movea.l   4(%a5),%a0
		move.l    (%a0),%d0
		jbra      TokensExec_AddResult_Func_Integer

|===|
|CVF|
|===|		
ExecFnc_Cvf:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    (%a5),%d0				|Oprande
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type
		cmpi.b    #TYPE_STRING,%d0
		jbne      _ERROR_types_incompatible
		
		movea.l   4(%a5),%a0
		move.l    (%a0)+,%d0
		move.l    (%a0)+,%d1
		move.w    (%a0),%d2
		jbra      TokensExec_AddResult_Func_Float

|=======|
|SETFONT|
|=======|		
ExecCmd_Setfont:
		TokensExec_Cmd_CheckArg		#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type number
		move.b    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		move.l    (%a0),%d3
		cmpi.b    #3,%d3
		jbcs      _ExecCmd_Setfont_next
		moveq.l   #2,%d3
_ExecCmd_Setfont_next:
		move.w    %d3,-(%SP)
		ROM_CALL  FontSetSys
		addq.l    #2,%SP
		
		lea.l     PARAM_FONT(%PC),%a0
		move.b    %d3,(%a0)
		lea.l     PARAM_FONT_DIVx(%PC),%a0
		lea.l     PARAM_FONT_DIVy(%PC),%a1
		tst.b     %d3
		jbeq      _ExecCmd_Setfont_F_4x6
		subq.l    #1,%d3
		jbeq      _ExecCmd_Setfont_F_6x8
_ExecCmd_Setfont_F_8x10:		
		move.b    #8,(%a0)
		move.b    #10,(%a0)
		jbra      TokensExec_EndTokenCmd
		
_ExecCmd_Setfont_F_4x6:
		move.b    #4,(%a0)
		move.b    #6,(%a0)
		jbra      TokensExec_EndTokenCmd
		
_ExecCmd_Setfont_F_6x8:
		move.b    #6,(%a0)
		move.b    #8,(%a0)
		jbra      TokensExec_EndTokenCmd

|=======|
|GETFONT|
|=======|		
ExecFnc_Getfont:
		jbsr      TokensExec_NumArg
		moveq.l   #0,%d0
		move.b    PARAM_FONT(%PC),%d0
		jbra      TokensExec_AddResult_Func_Integer
		
ExecFnc_Lower:
		rts
		
ExecCmd_Run:
		rts

|=======|
|NGETCHX|
|=======|		
ExecFnc_Ngetchx:
		jbsr      TokensExec_NumArg
_ExecFnc_Ngetchx_loop:		
		jbsr      _kb_getkey
		tst.w     %d0
		jbeq      _ExecFnc_Ngetchx_loop
		andi.l    #0x0000FFFF,%d0
		jbra      TokensExec_AddResult_Func_Integer

|===|
|RND|
|===|		
ExecFnc_Rnd:
		jbsr      TokensExec_NumArg
		
		jbsr      rand
		move.w    %d0,%a0
		move.l    %a0,-(%SP)
		move.w    #flt*4,-(%SP)				|Wrapper
		jbsr      __BC
		clr.w     -(%SP)				|Divise par 32767
	        move.l    #0x70000000,-(%SP)
	        move.l    #0x40043276,-(%SP)
		move.w    %d2,-(%SP)
	        move.l    %d1,-(%SP)
	        move.l    %d0,-(%SP)
	        move.w    #fdiv*4,-(%SP)			|Wrapper
		jbsr      __BC
	        lea.l     28(%SP),%SP
	        jbra      TokensExec_AddResult_Func_Float 

|=====|
|TIMER|
|=====|		
ExecFnc_Timer:
		jbsr      TokensExec_NumArg
		
		move.l    counter_time(%PC),%d0
		jbra      TokensExec_AddResult_Func_Integer
		
ExecCmd_System:
		rts
		
ExecFnc_Crslin:
		rts
		
ExecFnc_Crscol:
		rts
		
|======|
|RANDOM|
|======|	
ExecFnc_Random:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Conversion en entier
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Rcupre nombre
		movea.l   4(%a5),%a0
		move.l    (%a0),%d3
		jbsr      rand
		mulu.w    %d3,%d0
		jbpl      _ExecFnc_Random_next
		addi.l    #32767,%d0
_ExecFnc_Random_next:
		moveq.l   #15,%d2
		asr.l     %d2,%d0
		jbra      TokensExec_AddResult_Func_Integer
		
ExecFnc_Type:
		rts
		
ExecFnc_Lval:
		rts
		
ExecFnc_Varptr:
		rts
		
ExecFnc_Arrptr:
		rts
		
ExecFnc_Dfree:
		rts

|====|
|PEEK|
|====|		
ExecFnc_Peek:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Conversion en entier
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0
		movea.l   (%a0),%a0
		
		moveq.l   #0,%d0
		move.b    (%a0),%d0 
		jbra      TokensExec_AddResult_Func_Integer

|=====|
|DPEEK|
|=====|		
ExecFnc_Dpeek:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Conversion en entier
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0
		movea.l   (%a0),%a0
		
		moveq.l   #0,%d0
		move.b    (%a0)+,%d0
		lsl.w     #8,%d0
		move.b    (%a0),%d0
		jbra      TokensExec_AddResult_Func_Integer

|=====|
|LPEEK|
|=====|		
ExecFnc_Lpeek:
		TokensExec_Func_CheckArg	#1
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Conversion en entier
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0
		movea.l   (%a0),%a0
		
		moveq.l   #0,%d0
		move.b    (%a0)+,%d0
		lsl.w     #8,%d0
		move.b    (%a0)+,%d0
		lsl.l     #8,%d0
		move.b    (%a0)+,%d0
		lsl.l     #8,%d0
		move.b    (%a0),%d0
		jbra      TokensExec_AddResult_Func_Integer

|====|
|POKE|
|====|			
ExecCmd_Poke:
		TokensExec_Cmd_CheckArg		#2
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert Number
		move.b    1(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert Adresse
		move.b    13(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     12(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		movea.l   16(%a5),%a1				|Adresse
		movea.l   (%a1),%a1
		move.b    3(%a0),(%a1)
		jbra      TokensExec_EndTokenCmd

|=====|
|DPOKE|
|=====|			
ExecCmd_Dpoke:
		TokensExec_Cmd_CheckArg		#2
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert Number
		move.b    1(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert Adresse
		move.b    13(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     12(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		movea.l   16(%a5),%a1				|Adresse
		movea.l   (%a1),%a1
		move.b    2(%a0),(%a1)+
		move.b    3(%a0),(%a1)
		jbra      TokensExec_EndTokenCmd

|=====|
|LPOKE|
|=====|		
ExecCmd_Lpoke:	
		TokensExec_Cmd_CheckArg		#2
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert Number
		move.b    1(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert Adresse
		move.b    13(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     12(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number
		movea.l   16(%a5),%a1				|Adresse
		movea.l   (%a1),%a1
		move.b    (%a0)+,(%a1)+
		move.b    (%a0)+,(%a1)+
		move.b    (%a0)+,(%a1)+
		move.b    (%a0),(%a1)
		jbra      TokensExec_EndTokenCmd

|===|
|BOX|
|===|		
ExecCmd_Box:
		TokensExec_Cmd_CheckArg		#4
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert number 1
		move.b    1(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert number 2
		move.b    13(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     12(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert number 3
		move.b    25(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     24(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert number 4
		move.b    37(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     36(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number 1
		movea.l   16(%a5),%a1				|Number 2
		movea.l   28(%a5),%a2				|Number 3
		movea.l   40(%a5),%a3				|Number 4
		move.w    2(%a0),-(%SP)				|Number x...
		move.w    2(%a1),-(%SP)
		move.w    2(%a2),-(%SP)
		move.w    2(%a3),-(%SP)
		move.w    #A_NORMAL,-(%SP)			|Attribut
		pea.l     SCR_RECT(%PC)				|SRC_RECT *clip
		pea.l     6(%SP)
		ROM_CALL  DrawClipRect
		lea.l     18(%SP),%SP
		jbra      TokensExec_EndTokenCmd

|=====|
|INPUT|
|=====|
_ExecCmd_Input_eofline:
		pea.l     printf_eofline(%PC)
		jbsr      printf
		addq.l    #4,%SP
		jbra      _ExecCmd_Input_loop_end2

_ExecCmd_Input_show_text:
		move.l    4(%a5),-(%SP)
		pea.l     printf_s(%PC)
		jbsr      printf
		addq.l    #8,%SP
		jbra      _ExecCmd_Input_loop_end

_ExecCmd_Input_ParamAT:
		lea.l     PARAM_PRINT_AT(%PC),%a0		|Place curseur de texte aux coordonnes spcifies par AT
		clr.w     (%a0)			
		move.w    PARAM_PRINT_REAL_ATy(%PC),-(%SP)
		move.w    PARAM_PRINT_REAL_ATx(%PC),-(%SP)
		ROM_CALL  MoveTo
		addq.l    #4,%SP
		dbf       %d6,_ExecCmd_Input_loop
		jbra      TokensExec_EndTokenCmd
		
ExecCmd_Input:
		jbsr      TokensExec_CNumArg
		tst.w     %d6
		jbeq      _ERROR_few_arguments
				
		movea.l   ptrEnd_ES(%PC),%a5			|Place la pile au dbut de la premire donnes
		lea.l     -12(%a5),%a5
		
		move.w    PARAM_PRINT_AT(%PC),%d0
		jbeq      _ExecCmd_Input_continue
		move.b    (%a5),%d0				|Oprande
		cmpi.b    #OPRD_POINT_VIRGULE,%d0
		jbne      _ExecCmd_Input_continue
		subq.l    #1,%d6
		lea.l     -12(%a5),%a5				|Donnes suivante
_ExecCmd_Input_continue:
		movea.l   %a5,%a3
		moveq.l   #0,%d5
		move.w    %d6,%d5
		subq.l    #1,%d5
		move.w    PARAM_PRINT_AT(%PC),%d0
		jbne      _ExecCmd_Input_ParamAT
		dbf       %d6,_ExecCmd_Input_loop
		jbra      TokensExec_EndTokenCmd
		
_ExecCmd_Input_loop:
		move.b    (%a5),%d0				|Oprande
		tst.l     %d6
		jbne      _ExecCmd_Input_loop_next
		cmpi.b    #OPRD_STRING,%d0
		jbeq      _ERROR_syntax
		cmpi.b    #OPRD_POINT_VIRGULE,%d0
		jbeq      _ERROR_syntax
		
_ExecCmd_Input_loop_next:
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Point virgule
		cmpi.b    #OPRD_POINT_VIRGULE,%d0
		jbeq      _ExecCmd_Input_loop_end2
		
		cmpi.b    #OPRD_VAR,%d0
		jbeq      _ExecCmd_Input_loop_next2
		cmpi.b    #OPRD_VARTABLE,%d0
		jbeq      _ExecCmd_Input_loop_next2
		cmpi.b    #OPRD_STRING,%d0
		jbne      _ERROR_incorrect_arg
		cmp.w     %d5,%d6
		jbne      _ERROR_incorrect_arg
_ExecCmd_Input_loop_next2:		
		|Affiche texte
		cmpi.b    #OPRD_STRING,%d0
		jbeq      _ExecCmd_Input_show_text
_ExecCmd_Input_loop_Incorrect_Input:
		move.w    %d5,%d0
		subi.w    #1,%d0
		cmp.w     %d0,%d6
		jbne      _ExecCmd_Input_show_interro
		cmpi.b    #OPRD_STRING,(%a3)
		jbne      _ExecCmd_Input_show_interro
		cmpi.b    #OPRD_POINT_VIRGULE,-12(%a3)
		jbne      _ExecCmd_Input_loop_next3     
_ExecCmd_Input_show_interro:		
		|Point d'interrogation
		pea.l     printf_i(%PC)
		jbsr      printf
		addq.l    #4,%SP
_ExecCmd_Input_loop_next3:
		move.w    PARAM_INPUT_LENGTH(%PC),%d1
		move.l    string_buffer(%PC),%a2
		jbsr      Func_InputStr
		
		|Chane de caractre
		move.b    1(%a5),%d1				|Type
		cmpi.b    #TYPE_STRING,%d1
		jbeq      _ExecCmd_Input_write_string
		
		|Nombre avec base (&H, &X ou &O)
		moveq.l   #0,%d1
		move.w    %d0,%d1
		dbf       %d1,_ExecCmd_Input_loop_find_base
		jbra      _ExecCmd_Input_loop_next4
_ExecCmd_Input_loop_find_base:
		cmpi.b    #'&',(%a2)
		jbeq	  _ExecCmd_Input_write_base
		cmpi.b    #32,(%a2)+
		jbne      _ExecCmd_Input_loop_next4
		dbf       %d1,_ExecCmd_Input_loop_find_base
		jbra      _ExecCmd_Input_loop_Error_input
|Ecriture d'un simple nombre
_ExecCmd_Input_loop_next4:
		addq.l    #1,%d1
		move.w    %d1,%d0
		lea.l     -1(%a2),%a0
		movea.l   %a0,%a1
		jbsr      Func_StrToFloat
		tst.w     %d7
		jbeq      _ExecCmd_Input_loop_Error_input
		
|Vrification du nombre entr
		movea.l   4(%a5),%a3
		move.b    1(%a5),%d3				|Type
		cmpi.b    #TYPE_INTEGER,%d3
		jbeq      _ExecCmd_Input_write_number_integer
		cmpi.b    #TYPE_BOOL,%d3
		jbeq      _ExecCmd_Input_write_number_bool
		move.l    %d0,(%a3)+				|Empile 4 octets dbut flottant
		move.l    %d1,(%a3)+				|Empile 4 octets suivant flottant
		move.w    %d2,(%a3)+				|Empile 2 octets fin flottant     
		
_ExecCmd_Input_loop_end:
		tst.w     %d6
		jbeq      _ExecCmd_Input_eofline
		move.b    (%a5),%d0
		cmpi.b    #OPRD_STRING,%d0
		jbne      _ExecCmd_Input_eofline
_ExecCmd_Input_loop_end2:		
		lea.l     -12(%a5),%a5				|Donnes suivante
		dbf       %d6,_ExecCmd_Input_loop
		jbra      TokensExec_EndTokenCmd

|Erreur de donnes
_ExecCmd_Input_loop_Error_input:
		pea.l     printf_eofline(%PC)
		jbsr      printf
		addq.l    #4,%SP
		|if (number (StartArg).operand==OPRD_STRING && (i==StartArg+1 || (i==StartArg+2 && number (StartArg+1).operand==OPRD_POINT_VIRGULE)))
		cmpi.b    #OPRD_STRING,(%a3)
		jbne      _ExecCmd_Input_loop_Incorrect_Input
		move.w    %d5,%d0
		subi.w    #1,%d0
		cmp.w     %d0,%d6
		jbeq      _ExecCmd_Input_loop_Error_input_next
		subi.w    #1,%d0
		cmp.w     %d0,%d6
		jbne      _ExecCmd_Input_loop_Incorrect_Input
		cmpi.b    #OPRD_POINT_VIRGULE,-12(%a3)
		jbne      _ExecCmd_Input_loop_Error_input_next
_ExecCmd_Input_loop_Error_input_next:
		move.l    4(%a3),-(%SP)
		pea.l     printf_s(%PC)
		jbsr      printf
		addq.l    #8,%SP
		jbra      _ExecCmd_Input_loop_Incorrect_Input

|Ecriture des donnes
_ExecCmd_Input_write_string:
		|Allocation chane de caractre
		move.w    %d0,%d3
		movea.l   %a5,%a2
		jbsr      TokensExec_NewString
		tst.w     %d7   
		jbeq      _Exec_exit
		
		|Ecriture des donnes
		move.w    %d3,%d0
		movea.l   %a0,%a1
		move.l    string_buffer(%PC),%a0
		jbsr      TokensExec_CopyString
		jbra      _ExecCmd_Input_loop_end
		
|Ecriture d'un nombre dans une base!
_ExecCmd_Input_write_base:
		addq.l    #1,%d1
		jbsr      Func_StrToBase
		tst.w     %d7
		jbeq      _ExecCmd_Input_loop_Error_input
		movea.l   4(%a5),%a4				|Zone de donnes
		move.b    1(%a5),%d1				|Type
		cmpi.b    #TYPE_FLOAT,%d1
		jbeq      _ExecCmd_Input_write_base_float
		cmpi.b    #TYPE_BOOL,%d1
		jbeq      _ExecCmd_Input_write_base_bool
		move.l    %d0,(%a4)
		jbra      _ExecCmd_Input_loop_end
		
_ExecCmd_Input_write_base_float:
		move.l    %d0,-(%SP)
		move.w    #flt*4,-(%SP)				|Wrapper
		jbsr      __BC
		addq.l    #6,%SP
		movea.l   4(%a5),%a0
		move.l    %d0,(%a0)+				|Empile 4 octets dbut flottant
		move.l    %d1,(%a0)+				|Empile 4 octets suivant flottant
		move.w    %d2,(%a0)+				|Empile 2 octets fin flottant
		jbra      _ExecCmd_Input_loop_end
		
_ExecCmd_Input_write_base_bool:
		moveq.l   #0,%d1
		tst.l     %d0					|Si donnes -1 sinon 0
		sne       %d1
		move.b    %d1,(%a4)
		jbra      _ExecCmd_Input_loop_end

_ExecCmd_Input_write_number_integer:
		move.w    %d2,-(%SP)				|Empile fin flottant
		move.l    %d1,-(%SP)				|Empile milieu flottant
		move.l    %d0,-(%SP)				|Empile dbut flottant
		ROM_CALL  trunc
		lea.l     10(%SP),%SP
		move.l    %d0,(%a3)
		jbra      _ExecCmd_Input_loop_end
		
_ExecCmd_Input_write_number_bool:
		move.w    #0x4000,-(%SP)			|Place flottant = 0 dans SP
		clr.l     -(%SP)
		clr.l     -(%SP)				|Va  l'adresse o se trouve le flottant
		move.w    %d2,-(%SP)				|Empile fin flottant
		move.l    %d1,-(%SP)				|Empile milieu flottant
		move.l    %d0,-(%SP)				|Empile dbut flottant
		ROM_CALL  fcmp
		lea.l     20(%SP),%SP
		tst.l     %d0					|Si %d0 diffrent de 0
		sne       %d0					|Remplie %d0 de 1 Flag Z
		move.b    %d0,(%a3)
		jbra      _ExecCmd_Input_loop_end
		
ExecCmd_Text:
		rts

|====|
|PLOT|
|====|		
ExecCmd_Plot:
		TokensExec_Cmd_CheckArg		#2
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert number 1
		move.b    1(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert number 2
		move.b    13(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     12(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   16(%a5),%a1				|Number 2
		movea.l   4(%a5),%a0				|Number 1
		move.w    2(%a0),-(%SP)
		move.w    2(%a1),-(%SP)
		ROM_CALL  DrawClipPix
		addq.l    #4,%SP
		jbra      TokensExec_EndTokenCmd

|====|
|LINE|
|====|		
ExecCmd_Line:
		TokensExec_Cmd_CheckArg		#4
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert number 1
		move.b    1(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert number 2
		move.b    13(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     12(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert number 3
		move.b    25(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     24(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Convert number 4
		move.b    37(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     36(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0				|Number 1
		movea.l   16(%a5),%a1				|Number 2
		movea.l   28(%a5),%a2				|Number 3
		movea.l   40(%a5),%a3				|Number 4
		move.w    2(%a0),-(%SP)				|Number x...
		move.w    2(%a1),-(%SP)
		move.w    2(%a2),-(%SP)
		move.w    2(%a3),-(%SP)
		move.w    #A_NORMAL,-(%SP)			|Attribut
		pea.l     SCR_RECT(%PC)				|SRC_RECT *clip
		pea.l     6(%SP)
		ROM_CALL  DrawClipLine
		lea.l     18(%SP),%SP
		jbra      TokensExec_EndTokenCmd
		
|====|
|READ|
|====|
_ExecCmd_Read_type_MSB:
		lsr.b     #4,%d0				|MSB
		jbra      _ExecCmd_Read_loop_continue
		
_ExecCmd_Read_float:
		subq.l    #4,%a2				|Saute adresse tableau...
		move.l    (%a0),-(%a2)				|Empile adresse dans ES
		lea.l     -2(%a2),%a2				|Saute les 2 octets d'infos supplmentaires
		move.b    #TYPE_FLOAT,-(%a2)			|Empile type de donnes
		move.b    #OPRD_NUMBER,-(%a2)			|Empile Oprande
		add.l     #SIZE_FLOAT,(%a0)			|Avance pointeur de donnes
		move.b    #TYPE_FLOAT,%d0			|Type pour data
		jbra      _ExecCmd_Read_loop_continue2

_ExecCmd_Read_integer16:
		movea.l   (%a0),%a1				|Zone de donne
		clr.w     -16(%a2)				|Efface MSB du nombre temporaire
		move.w    (%a1),-14(%a2)			|Nombre sur 16 Bits
		lea.l     -16(%a2),%a1				|%a1 = Adresse de la donne temporaire
		subq.l    #4,%a2				|Saute adresse tableau...
		move.l    %a1,-(%a2)				|Empile adresse dans ES
		lea.l     -2(%a2),%a2				|Saute les 2 octets d'infos supplmentaires
		move.b    #TYPE_INTEGER,-(%a2)			|Empile type de donnes
		move.b    #OPRD_NUMBER,-(%a2)			|Empile Oprande
		addq.l    #SIZE_INTEGER16,(%a0)			|Avance pointeur de donnes
		move.b    #TYPE_INTEGER,%d0			|Type pour data
		jbra      _ExecCmd_Read_loop_continue2
		
_ExecCmd_Read_integer32:
		subq.l    #4,%a2				|Saute adresse tableau...
		move.l    (%a0),-(%a2)				|Empile adresse dans ES
		lea.l     -2(%a2),%a2				|Saute les 2 octets d'infos supplmentaires
		move.b    #TYPE_INTEGER,-(%a2)			|Empile type de donnes
		move.b    #OPRD_NUMBER,-(%a2)			|Empile Oprande
		addq.l    #SIZE_INTEGER,(%a0)			|Avance pointeur de donnes
		move.b    #TYPE_INTEGER,%d0			|Type pour data
		jbra      _ExecCmd_Read_loop_continue2

_ExecCmd_Read_string_add_NULL:
		addq.l    #1,(%a0)
		jbra      _ExecCmd_Read_loop_continue2
		
_ExecCmd_Read_string:
		movea.l   (%a0),%a1				|Zone de donne
		moveq.l   #0,%d1				|Efface %d1
		move.w    (%a1),%d1				|Taille de la chane
		addq.l    #2,(%a0)				|Saute octet NULL+taille
		subq.l    #4,%a2				|Saute adresse tableau...
		move.l    (%a0),-(%a2)				|Empile adresse de la chane de caractres
		move.w    %d1,-(%a2)				|Empile taille de la chane de caractres
		move.b    #TYPE_STRING,-(%a2)			|Empile type de donnes
		move.b    #OPRD_STRING,-(%a2)			|Empile oprande
		addi.w    #1,%d1				|Caractre NULL
		add.l     %d1,(%a0)				|Avance de la taille de la chane
		move.b    #TYPE_STRING,%d0			|Type pour data
		andi.b    #1,%d1				|Si taille paire
		jbne      _ExecCmd_Read_string_add_NULL
		jbra      _ExecCmd_Read_loop_continue2

_ExecCmd_Read_write_float:
		move.l    (%a1)+,(%a0)+				|Ecrit flottant
		move.l    (%a1)+,(%a0)+
		move.w    (%a1),(%a0)
		jbra      _ExecCmd_Read_loop_continue3
		
_ExecCmd_Read_write_integer:
		move.l    (%a1),(%a0)
		jbra      _ExecCmd_Read_loop_continue3
		
_ExecCmd_Read_write_string:
		|Cration allocation
		move.w	  2(%a2),%d3				|Taille de la chane de caractres source
		movea.l   4(%a2),%a3				|Zone chane de caractre source
		movea.l   %a5,%a2				|Zone pile ES, chaine de caractres de destination
		jbsr      TokensExec_NewString
		tst.w     %d7
		jbeq      _ExecCmd_Read_exit
		
		|Copie chane de caractre
		move.w    %d3,%d0				|Taille de la chane de caractre  copier
		movea.l   %a0,%a1
		movea.l   %a3,%a0
		jbsr      TokensExec_CopyString
		jbra      _ExecCmd_Read_loop_continue3
		
		/*|Prpare allocation
		moveq.l   #0,%d0
		move.w	  2(%a2),%d0				|Taille de la chane de caractres
		addq.l    #1,%d0				|Caractre NULL		
		lea.l     EMPTY_STRING(%PC),%a1			|Adresse chane vide
		cmpa.l    %a0,%a1				|Chane non vide?
		jbne      _ExecCmd_Read_write_string_reallocate
_ExecCmd_Read_write_string_allocate:
		move.l    %d0,-(%SP)
		ROM_CALL  malloc
		addq.l    #4,%SP
		jbra      _ExecCmd_Read_write_string_end_allocate
		
_ExecCmd_Read_write_string_reallocate:
		move.w    2(%a5),%d1
		addi.w    #1,%d1
		cmp.w     %d0,%d1
		jbcc      _ExecCmd_Read_write_string_end_allocate|Evite une rallocation dans le cas o l'espace mmoire est suffisant! 7x plus rapide!
		jbsr      realloc
		
_ExecCmd_Read_write_string_end_allocate:
		move.l    %a0,%d0
		|tst.l     %d0
		jbeq      _ExecCmd_Read_write_string_error_memory
		move.l    8(%a5),%a1				|Adresse descripteur
		move.l    %a0,(%a1)+				|Change adresse de la chane dans le descripteur
		move.w    2(%a2),%d0				|Taille de la chane
		move.w    %d0,(%a1)				|Change taille de la chane dans le descripteur
		movea.l   %a0,%a1
		movea.l   4(%a2),%a0
		jbsr      TokensExec_CopyString
		|lea.l     24(%a5),%a5				|Dpile ES de 2 items
		jbra      _ExecCmd_Read_loop_continue3*/

_ExecCmd_Read_write_string_error_memory:
		lea.l     12(%SP),%SP
		jbra      _ERROR_no_enough_memory
		
ExecCmd_Read:
		jbsr      TokensExec_CNumArg
		movea.l   ptrEnd_ES(%PC),%a5			|Place la pile au dbut de la premire donnes
		lea.l     -12(%a5),%a5
		lea.l     -16(%SP),%SP				|Dfinie zone temporaire ES+Nombre temporaire
		dbf       %d6,_ExecCmd_Read_loop
		
_ExecCmd_Read_loop:
		|Out of data?
		lea.l     sDATA_number(%PC),%a0			|Donne en cours
		move.w    (%a0),%d1				|%d1 = sDATA_number
		cmp.w     sDATA_total_number(%PC),%d1		|Dpassement des donnes
		jbcc      _ExecCmd_Read_error_out_of_data	
		add.w     #1,(%a0)				|Donne suivante
				
		|Lecture type de la donne
		movea.l   sDATA_type_ptr(%PC),%a0		|Zone de typage dans %a0
		move.w    %d1,%d0				|%d0 = sDATA_number
		lsr.w     #1,%d0				|Prpare lecture de l'octet de typage
		lea.l     (%d0.w,%a0),%a0			|Ce place sur l'octet de typage
		move.b    (%a0),%d0				
		andi.w    #1,%d1				|Rcupre MSB ou LSB
		jbeq      _ExecCmd_Read_type_MSB		|MSB
		andi.b    #0x0F,%d0				|LSB
_ExecCmd_Read_loop_continue:
		|Avance pointeur de donne et ecriture d'une pile ES
		lea.l     sDATA_ptr(%PC),%a0			|Pointeur de donnes
		lea.l     16(%SP),%a2				|Zone ES temporaire!
		
		|Ecriture dans la pile temporaire ES
		cmpi.b    #DATA_FLOAT,%d0
		jbeq      _ExecCmd_Read_float
		cmpi.b    #DATA_INTEGER16,%d0
		jbeq      _ExecCmd_Read_integer16
		cmpi.b    #DATA_INTEGER32,%d0
		jbeq      _ExecCmd_Read_integer32
		cmpi.b    #DATA_STRING,%d0
		jbeq      _ExecCmd_Read_string
		
_ExecCmd_Read_loop_continue2:	
		|Conversion de type number -> var
		move.b    1(%a5),%d1
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _ExecCmd_Read_exit	
		
		|Affectation
		move.b    1(%a5),%d0
		movea.l   4(%a2),%a1				|Number
		movea.l   4(%a5),%a0				|Variable
		cmpi.b    #TYPE_FLOAT,%d0
		jbeq      _ExecCmd_Read_write_float
		cmpi.b    #TYPE_INTEGER,%d0
		jbeq      _ExecCmd_Read_write_integer
		cmpi.b    #TYPE_STRING,%d0
		jbeq      _ExecCmd_Read_write_string

_ExecCmd_Read_loop_continue3:		
		lea.l     -12(%a5),%a5				|Donnes suivante
		dbf       %d6,_ExecCmd_Read_loop
		lea.l     16(%SP),%SP				|Efface zone temporaire ES
		jbra      TokensExec_EndTokenCmd
		
_ExecCmd_Read_exit:
		lea.l     16(%SP),%SP				|Efface zone temporaire ES
		rts
		
_ExecCmd_Read_error_out_of_data:
		lea.l     16(%SP),%SP				|Efface zone temporaire ES
		jbra      _ERROR_out_of_data

|======|
|SPRITE|
|======|
/*SIMPLE SPRITE (NO MASKED)*/
/*ClipSprite16_OR_R Source ExtGraph v2.0 bta 4.0*/
_ExecCmd_Sprite_ClipSprite_NOMASK_MODE_or:
		or.l      %d1,(%a3)
		rts

_ExecCmd_Sprite_ClipSprite_NOMASK_MODE_xor:
		eor.l     %d1,(%a3)
		rts

_ExecCmd_Sprite_ClipSprite_NOMASK_MODE:
		cmpi.b    #SPRT_XOR,%d2
		jbeq      _ExecCmd_Sprite_ClipSprite_NOMASK_MODE_xor
		jbra      _ExecCmd_Sprite_ClipSprite_NOMASK_MODE_or

_ExecCmd_Sprite_ClipSprite_NOMASK:
    		move.w    %d1,%d3				|%d3 = y
    		jbpl      _ExecCmd_Sprite_ClipSprite_NOMASK_9	|h > 0 ?

    		add.w     %d1,%d5				|%d5 = h + y
   		jbmi      _ExecCmd_Sprite_ClipSprite_NOMASK_0	|y + h < 0 ?

    		add.w     %d1,%d1				|%d1 = 2y
    		suba.w    %d1,%a4				|sprt -= 2y
    		moveq.l   #0,%d1				|offsety = 0
    		jbra      _ExecCmd_Sprite_ClipSprite_NOMASK_10

_ExecCmd_Sprite_ClipSprite_NOMASK_9:
    		add.w     %d5,%d3				|%d3 = h + y
    		subi.w    #MAX_LCD_HEIGHT,%d3			|%d3 = h + y - 127
    		jble      _ExecCmd_Sprite_ClipSprite_NOMASK_6	|h + y - 127 <= 0 ?
    		sub.w     %d3,%d5				|h -= h + y - 127 (h = 127-y)
    		jbmi      _ExecCmd_Sprite_ClipSprite_NOMASK_0

_ExecCmd_Sprite_ClipSprite_NOMASK_6:
    		move.w    %d1,%d3
    		lsl.w     #4,%d1
    		sub.w     %d3,%d1				|%d1 = y*15

_ExecCmd_Sprite_ClipSprite_NOMASK_10:
    		move.w    %d0,%d3				|%d3 = x
    		jble      _ExecCmd_Sprite_ClipSprite_NOMASK_8	|x < 0 ?
    		cmpi.w    #MAX_LCD_WIDTH-16,%d0
    		jbhi      _ExecCmd_Sprite_ClipSprite_NOMASK_7	|x > 239-15

    		lsr.w     #4,%d3				|%d3 = x/16
    		add.w     %d3,%d1				|%d3 = x/16 + y*15
    		add.w     %d1,%d1				|%d3 = x/8 + y*30
    		adda.w    %d1,%a3				|dest += offset

    		andi.w    #15,%d0
    		cmpi.w    #8,%d0
    		jbge      _ExecCmd_Sprite_ClipSprite_NOMASK_3
    
_ExecCmd_Sprite_ClipSprite_NOMASK_1:
    		moveq.l   #0,%d1
    		move.w    (%a4)+,%d1
    		swap      %d1
    		lsr.l     %d0,%d1
    		jbsr	  _ExecCmd_Sprite_ClipSprite_NOMASK_MODE
    		lea       30(%a3),%a3
    		dbf       %d5,_ExecCmd_Sprite_ClipSprite_NOMASK_1
    		jbra      TokensExec_EndTokenCmd

_ExecCmd_Sprite_ClipSprite_NOMASK_3:
    		moveq.l   #16,%d1
    		sub.w     %d0,%d1
    		
    		/*moveq.l   #16,%d6
    		sub.w     %d1,%d6
    		move.w    %d6,%d0*/
    		move.w    %d1,%d0
_ExecCmd_Sprite_ClipSprite_NOMASK_2:
    		moveq.l   #0,%d1
    		move.w    (%a4)+,%d1
    		/*swap      %d1
    		lsr.l     %d0,%d1*/
    		lsl.l     %d0,%d1
    		jbsr	  _ExecCmd_Sprite_ClipSprite_NOMASK_MODE
    		lea       30(%a3),%a3
    		dbf       %d5,_ExecCmd_Sprite_ClipSprite_NOMASK_2

_ExecCmd_Sprite_ClipSprite_NOMASK_0:
    		jbra      TokensExec_EndTokenCmd

_ExecCmd_Sprite_ClipSprite_NOMASK_8:
    		cmpi.w    #MIN_LCD_WIDTH-16,%d0
    		jble      _ExecCmd_Sprite_ClipSprite_NOMASK_0	|x <= -16 ?
    		neg.w     %d0					|shift = -x
    		add.w     %d1,%d1				|%d1 = y*30
    		adda.w    %d1,%a3				|dest += offset
    		
_ExecCmd_Sprite_ClipSprite_NOMASK_4:
    		moveq.l   #0,%d1
    		move.w    (%a4)+,%d1
    		swap      %d1
    		lsl.l     %d0,%d1				|shifting
    		jbsr	  _ExecCmd_Sprite_ClipSprite_NOMASK_MODE
    		lea.l     30(%a3),%a3
    		dbf       %d5,_ExecCmd_Sprite_ClipSprite_NOMASK_4
    		jbra      TokensExec_EndTokenCmd

_ExecCmd_Sprite_ClipSprite_NOMASK_7:
    		cmpi.w    #MAX_LCD_WIDTH,%d0
    		jbhi      _ExecCmd_Sprite_ClipSprite_NOMASK_0	|x > 239
    		andi.w    #15,%d0				|shiftx = x & 15
    		add.w     %d1,%d1				|%d1 = y*30
    		lea.l     28(%a3,%d1.w),%a3
    		
_ExecCmd_Sprite_ClipSprite_NOMASK_5:
    		moveq.l   #0,%d1
    		move.w    (%a4)+,%d1
    		lsr.l     %d0,%d1
    		swap      %d1
    		jbsr	  _ExecCmd_Sprite_ClipSprite_NOMASK_MODE
    		lea.l     30(%a3),%a3
    		dbf       %d5,_ExecCmd_Sprite_ClipSprite_NOMASK_5
    		jbra      TokensExec_EndTokenCmd


/*MASKED SPRITE*/
/*ClipSprite16_MASK_R Source ExtGraph v2.0 bta 4.0*/
_ExecCmd_Sprite_ClipSprite_MASK_nointerlaced:
		lea.l     2(%a4),%a2
		moveq.l   #2,%d2				|Gestion mode non entrelac
		jbra      _ExecCmd_Sprite_ClipSprite_MASK_continue
		
_ExecCmd_Sprite_ClipSprite_MASK:    		
    		cmpi.b    #1,%d4
    		jbne      _ExecCmd_Sprite_ClipSprite_MASK_nointerlaced
    		move.w    %d5,%d3				|Zone de masque
    		add.w     %d3,%d3
    		lea.l     (%d3.w,%a4),%a2
    		moveq.l   #0,%d2				|Gestion mode entrelac
    		
_ExecCmd_Sprite_ClipSprite_MASK_continue:
    		move.w    %d1,%d3				|%d3 = y
    		jbpl      _ExecCmd_Sprite_ClipSprite_MASK_9	|h > 0 ?
 
    		add.w     %d1,%d5				|%d5 = y + h
    		jbmi      _ExecCmd_Sprite_ClipSprite_MASK_0	|y + h < 0 ?
    		add.w     %d1,%d1				|%d1 = 2y
    		move.w    %d2,%d6				|Gestion sprite masqu
    		lsr.w     #1,%d6
    		lsl.w     %d6,%d1
    		suba.w    %d1,%a4				|sprt -= 2y
    		suba.w    %d1,%a2				|mask -= 2y
    		moveq.l   #0,%d1				|offsety = 0
    		jbra      _ExecCmd_Sprite_ClipSprite_MASK_10
    		
_ExecCmd_Sprite_ClipSprite_MASK_9:
    		add.w     %d5,%d3				|%d3 = h + y
    		subi.w    #MAX_LCD_HEIGHT,%d3			|%d3 = h + y - 127
    		jble      _ExecCmd_Sprite_ClipSprite_MASK_6	|h + y - 127 <= 0 ?		
    		sub.w     %d3,%d5				|h -= h + y - 127 (h = 127-y)
    		jbmi      _ExecCmd_Sprite_ClipSprite_MASK_0

_ExecCmd_Sprite_ClipSprite_MASK_6:
    		move.w    %d1,%d3
    		lsl.w     #4,%d1
    		sub.w     %d3,%d1				|%d1 = y*15
    		
_ExecCmd_Sprite_ClipSprite_MASK_10:
    		move.w    %d0,%d3				|%d3 = x
    		jble      _ExecCmd_Sprite_ClipSprite_MASK_8	|x < 0 ?
    		cmpi.w    #MAX_LCD_WIDTH-16,%d0
    		jbhi      _ExecCmd_Sprite_ClipSprite_MASK_7	|x > 239-15

    		lsr.w     #4,%d3				|%d3 = x/16
    		add.w     %d3,%d1				|%d3 = x/16 + y*15
    		add.w     %d1,%d1				|%d3 = x/8 + y*30
    		adda.w    %d1,%a3				|dest += offset
    		moveq.l   #16,%d1
    		andi.w    #15,%d0
    		sub.w     %d0,%d1				|%d1 = 16 - (x & 15)

_ExecCmd_Sprite_ClipSprite_MASK_1:
    		move.l    (%a3),%d3

    		moveq.l   #-1,%d0
    		move.w    (%a2)+,%d0
    		rol.l     %d1,%d0
    		and.l     %d0,%d3

    		moveq.l   #0,%d0
    		move.w    (%a4)+,%d0
    		lsl.l     %d1,%d0
    		or.l      %d0,%d3

    		move.l    %d3,(%a3)
    		lea.l     30(%a3),%a3
    		adda.w    %d2,%a4				|Gestion du sprite
    		adda.w    %d2,%a2				|Gestion du masque
    		dbf       %d5,_ExecCmd_Sprite_ClipSprite_MASK_1
    		
_ExecCmd_Sprite_ClipSprite_MASK_0:
    		jbra      TokensExec_EndTokenCmd

_ExecCmd_Sprite_ClipSprite_MASK_8:
    		cmpi.w    #MIN_LCD_WIDTH-16,%d0
    		jble      _ExecCmd_Sprite_ClipSprite_MASK_0     |x <= -16 ?
    		neg.w     %d0					|shift = -x
    		add.w     %d1,%d1				|%d1 = y*30
    		adda.w    %d1,%a3				|dest += offset
    		
_ExecCmd_Sprite_ClipSprite_MASK_4:
    		move.w    (%a3),%d3

    		moveq.l   #-1,%d1
    		move.w    (%a2)+,%d1
    		rol.l     %d0,%d1
    		and.w     %d1,%d3

    		move.w    (%a4)+,%d1
    		lsl.w     %d0,%d1				|shifting
    		or.w      %d1,%d3

    		move.w    %d3,(%a3)
    		lea.l     30(%a3),%a3
    		adda.w    %d2,%a4				|Gestion du sprite
    		adda.w    %d2,%a2				|Gestion du masque
    		dbf       %d5,_ExecCmd_Sprite_ClipSprite_MASK_4
    		jbra      TokensExec_EndTokenCmd

_ExecCmd_Sprite_ClipSprite_MASK_7:  
    		cmpi.w    #MAX_LCD_WIDTH,%d0
    		jbhi      _ExecCmd_Sprite_ClipSprite_MASK_0	|x > 239
    		andi.w    #15,%d0				|shiftx = x & 15
    		add.w     %d1,%d1				|%d1 = y*30
    		lea.l     28(%a3,%d1.w),%a3
    		
_ExecCmd_Sprite_ClipSprite_MASK_5:
    		move.w    (%a3),%d3

    		moveq.l   #-1,%d1
    		move.w    (%a2)+,%d1
    		asr.l     %d0,%d1
    		and.w     %d1,%d3

    		move.w    (%a4)+,%d1
    		lsr.w     %d0,%d1
    		or.w      %d1,%d3

    		move.w    %d3,(%a3)
    		lea.l     30(%a3),%a3
    		adda.w    %d2,%a4				|Gestion du sprite
    		adda.w    %d2,%a2				|Gestion du masque
    		dbf       %d5,_ExecCmd_Sprite_ClipSprite_MASK_5
		jbra      TokensExec_EndTokenCmd		

_ExecCmd_Sprite_mode:
		move.b    -35(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     -36(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   -32(%a5),%a0
		move.w    2(%a0),%d2
		jbra      _ExecCmd_Sprite_continue
		
_ExecCmd_Sprite_lcd_mem:
		move.b    -47(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     -48(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit		
		
		movea.l   -44(%a5),%a3
		movea.l   (%a3),%a3
		jbra      _ExecCmd_Sprite_continue2

_ExecCmd_Sprite_lenght_nomasked:
		addi.w    #6,%d1				|Ajoute taille header du sprite
		cmp.w     %d1,%d0
		jbcs      _ERROR_sprite_length_wrong
		jbra      _ExecCmd_Sprite_continue3
		
ExecCmd_Sprite:
		jbsr      TokensExec_CNumArg
		cmpi.w    #5,%d6				|Trop d'arguments
		jbhi      _ERROR_too_arguments
		cmpi.w    #3,%d6				|Pas assez d'arguments
		jbcs      _ERROR_few_arguments
		
		movea.l   ptrEnd_ES(%PC),%a5			|Place la pile au dbut de la premire donnes
		lea.l     -12(%a5),%a5
		
		|Sprite
		move.b    (%a5),%d0				|Oprande
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Type
		cmpi.b    #TYPE_STRING,%d0
		jbne      _ERROR_types_incompatible
		
		movea.l   4(%a5),%a4				|Pointeur donnes sprite
		addq.l    #4,%a4				|Saute coordonnes x,y
		move.b    (%a4)+,%d4				|Masked?
		moveq.l   #0,%d5				|Efface %d5
		move.b    (%a4)+,%d5  				|Hauteur en bits
		
		|Taille du sprite incorrecte?
		move.w    2(%a5),%d0				|Taille du sprite
		moveq.l   #0,%d1				|Efface %d1
		move.b    %d5,%d1				|%d1 = Hauteur
		add.w     %d1,%d1				|%d1 = Taille d'un sprite non masqu
		
		tst.b     %d4
		jbeq      _ExecCmd_Sprite_lenght_nomasked
		|Sprite mask
		add.w     %d1,%d1				|%d1 = Taille d'un sprite masqu
		addi.w    #6,%d1				|Ajoute taille header du sprite
		cmp.w     %d1,%d0
		jbcs      _ERROR_sprite_length_wrong
_ExecCmd_Sprite_continue3:
		|Coordonne X
		move.b    -11(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     -12(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Coordonne Y
		move.b    -23(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     -24(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
				
		|Zone mmoire
		cmpi.w    #5,%d6
		movea.l   #LCD_MEM,%a3				|Zone mmoire par dfaut
		jbeq      _ExecCmd_Sprite_lcd_mem
_ExecCmd_Sprite_continue2:
		|Mode d'affichage
		move.w    #SPRT_OR,%d2
		cmpi.w    #4,%d6
		jbcc      _ExecCmd_Sprite_mode
_ExecCmd_Sprite_continue:
		|Coordonnes
		movea.l   -8(%a5),%a0				|X
		move.w    2(%a0),%d0
		movea.l   -20(%a5),%a0				|Y
		move.w    2(%a0),%d1
		dbf       %d5,_ExecCmd_Sprite_continue4
		jbra      TokensExec_EndTokenCmd
		
_ExecCmd_Sprite_continue4:		
		|Affichage du sprite
		tst.b     %d4
		jbne      _ExecCmd_Sprite_ClipSprite_MASK
		jbra      _ExecCmd_Sprite_ClipSprite_NOMASK
		
|===|
|GET|
|===|
/*SpriteX8Get_R Source ExtGraph v2.0 bta 4.0*/
_ExecCmd_Get_Copy:
		add.w     %d1,%d1
		move.w	  %d1,%d4
		lsl.w	  #4,%d4
		sub.w	  %d1,%d4
	
		move.w	  %d0,%d1
		lsr.w	  #3,%d1
		add.w	  %d1,%d4
	
		adda.w	  %d4,%a3

		moveq.l   #30,%d2
		sub.w	  %d5,%d2				|constant offset from the end of a line to the beginning of the next one
		subq.w	  #2,%d5				|we need w-2 since first and last bytes are not in a loop
	
		and.w	  #7,%d0				|shifting coeff
		jbeq	  _ExecCmd_Get_Copy_2
	
		moveq.l   #8,%d3				|8-shift
		sub.w	  %d0,%d3
	
		subq.w	  #1,%d6

_ExecCmd_Get_Copy_0:
		move.b	  (%a3)+,%d4				|first byte of the line
		lsl.b	  %d0,%d4
		move.b	  %d4,(%a0)
	
		move.w	  %d5,%d1

_ExecCmd_Get_Copy_1:
		move.b	  (%a3),%d4				|middle bytes
		lsr.b	  %d3,%d4
		or.b	  %d4,(%a0)+
	
		move.b	  (%a3)+,%d4
		lsl.b	  %d0,%d4
		move.b	  %d4,(%a0)

		dbf	  %d1,_ExecCmd_Get_Copy_1

		move.b	  (%a3),%d4				|last byte of the line
		lsr.b	  %d3,%d4
		or.b	  %d4,(%a0)+
	
		adda.w	  %d2,%a3
		dbf	  %d6,_ExecCmd_Get_Copy_0
		jbra      TokensExec_EndTokenCmd

_ExecCmd_Get_Copy_2:						|loop if shift == 0
		addq.w	  #1,%d5
		subq.w	  #1,%d6
	
_ExecCmd_Get_Copy_3:
		move.w	  %d5,%d1
	
_ExecCmd_Get_Copy_4:
		move.b	  (%a3)+,(%a0)+
		dbf	  %d1,_ExecCmd_Get_Copy_4

		adda.w	  %d2,%a3
		dbf	  %d6,_ExecCmd_Get_Copy_3
		jbra      TokensExec_EndTokenCmd
	
_ExecCmd_Get_lcd_mem:
		move.b    -59(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     -60(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit		
		
		movea.l   -56(%a5),%a3
		movea.l   (%a3),%a3
		jbra      _ExecCmd_Get_continue
		
ExecCmd_Get:
		jbsr      TokensExec_CNumArg
		cmpi.w    #6,%d6				|Trop d'arguments
		jbhi      _ERROR_too_arguments
		cmpi.w    #5,%d6				|Pas assez d'arguments
		jbcs      _ERROR_few_arguments
		
		movea.l   ptrEnd_ES(%PC),%a5			|Place la pile au dbut de la premire donnes
		lea.l     -12(%a5),%a5
		
		|Coordonne X0
		move.b    1(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     (%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Coordonne Y0
		move.b    -11(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     -12(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Coordonne X1
		move.b    -23(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     -24(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Coordonne Y1
		move.b    -35(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     -36(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Chane de caractres
		move.b    -48(%a5),%d0				|Oprande
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    -47(%a5),%d0				|Type
		cmpi.b    #TYPE_STRING,%d0
		jbne      _ERROR_types_incompatible
				
		|Zone mmoire
		cmpi.w    #6,%d6
		movea.l   #LCD_MEM,%a3				|Zone mmoire par dfaut
		jbeq      _ExecCmd_Get_lcd_mem
		
_ExecCmd_Get_continue:
		movea.l   4(%a5),%a0				|X0
		move.w    2(%a0),%d0
		movea.l   -8(%a5),%a0				|Y0
		move.w    2(%a0),%d1
		movea.l   -20(%a5),%a0				|X1
		move.w    2(%a0),%d2
		movea.l   -32(%a5),%a0				|Y1
		move.w    2(%a0),%d3
		
		|Taille des donnes en cctets
		move.w    %d2,%d4				|Taille du sprite en largeur = X1-X0
		sub.w     %d0,%d4
		move.w    %d3,%d6
		sub.w     %d1,%d6				|Taille du sprite en hauteur = Y1-Y0
		
		|Calcul de bytewidth
		move.w    %d4,%d3
		addi.w    #7,%d3
		asr.w     #3,%d3
		move.w    %d3,%d5
		muls.w    %d6,%d3
		jble      _ERROR_incorrect_arg
		
		|Sauvegarde X0 et Y0
		move.w    %d1,-(%SP)
		move.w    %d0,-(%SP)
		
		|Cration de la chane de caractres
		addi.w    #4,%d3				|Taille header sprite
		lea.l     -48(%a5),%a2
		jbsr      TokensExec_NewString
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Restaure coordonnes
		move.w    (%SP)+,%d0				|X0
		move.w    (%SP)+,%d1				|Y0
		
		|Gestion erreur
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Header sprite
		move.w    %d4,(%a0)+				|Largeur
		move.w    %d6,(%a0)+      			|Hauteur
		jbra      _ExecCmd_Get_Copy
		
|===|
|PUT|
|===|
_ExecCmd_Put_Draw:
		|Zone de non affichage
		move.w    %d2,%d5				|%d5 = Bytewidth
		neg.w     %d5					|%d5 = -Bytewidth
		lsl.W     #3,%d5				|-Bytewidth*8
		cmp.w     %d5,%d0				|x<=%d5
		jble      TokensExec_EndTokenCmd
		cmpi.w    #MAX_LCD_WIDTH+1,%d0
		jbge      TokensExec_EndTokenCmd
		move.w    %d3,%d5				|%d5 = h
		neg.w     %d5					|%d5 = -h
		cmp.w     %d5,%d1
		jblt      TokensExec_EndTokenCmd
		cmpi.w    #MAX_LCD_HEIGHT+1,%d1
		jbge      TokensExec_EndTokenCmd
		
		|y<0
		tst.w     %d1
		jbge      _ExecCmd_Put_Draw_continue
		add.w     %d1,%d3				|h += y
		move.w    %d1,%d5				|%d5 = y
		muls.w    %d2,%d5				|y*Bytewidth
		suba.w    %d5,%a0				|sprite -= y*Bytewidth
		clr.w     %d1
_ExecCmd_Put_Draw_continue:
		|y+1>=MAX_LCD_HEIGHT
		move.w    %d1,%d5				|%d5 = y
		add.w     %d3,%d5				|%d5 = y+h
		cmpi.w    #MAX_LCD_HEIGHT+1,%d5
		jblt      _ExecCmd_Put_Draw_continue2
		move.w    #MAX_LCD_HEIGHT+1,%d3			|h = MAX_LCD_HEIGHT
		sub.w     %d1,%d3				|h = MAX_LCD_HEIGHT-y
_ExecCmd_Put_Draw_continue2:
		move.w    %d1,%d5				|%d5 = y
		add.w     %d5,%d5				|y*2
		asl.w     #5,%d1				|%d1 = y<<5
		sub.w     %d5,%d1				|(y<<5)-(y<<1)
		move.w    %d0,%d5				|%d5 = x
		asr.w     #3,%d5				|%d5 = x>>8
		add.w     %d5,%d1
		adda.w    %d1,%a3				|offset
		
		move.w    %d0,%d1				|%d1 = x
		andi.w    #7,%d1				|%d1 = x&7
		
		moveq.l   #8,%d4
		sub.w     %d1,%d4				|8-%d1
		
		move.w    #30,%d5
		sub.w     %d2,%d5
		
		|x<0
		tst.w     %d0
		jblt      _ExecCmd_Put_Draw_left
		move.w    %d2,%d6				|%d6 = Bytewidth
		lsl.w     #3,%d6				|%d6 = Bytewidth<<3
		add.w     %d0,%d6				|%d6 = (Bytewidth<<3)+x
		cmpi.w    #MAX_LCD_WIDTH+1,%d6
		jbge      _ExecCmd_Put_Draw_right
_ExecCmd_Put_Draw_normal:
		moveq.l   #0,%d0
		move.w    %d3,%d0
		dbf       %d0,_ExecCmd_Put_Draw_normal_loop
		jbra      TokensExec_EndTokenCmd
_ExecCmd_Put_Draw_normal_loop:
		moveq.l   #0,%d3
		move.b    (%a0),%d3
		lsr.w     %d1,%d3
		or.b      %d3,(%a3)+
		
		moveq.l   #0,%d7
		move.w    %d2,%d7
		subq.l    #1,%d7
		dbf       %d7,_ExecCmd_Put_Draw_normal_loop2
		jbra      _ExecCmd_Put_Draw_normal_loop2_continue
_ExecCmd_Put_Draw_normal_loop2:
		moveq.l   #0,%d3
		move.b    (%a0)+,%d3
		lsl.w     %d4,%d3
		or.b      %d3,(%a3)
		moveq.l   #0,%d3
		move.b    (%a0),%d3
		lsr.w     %d1,%d3
		or.b      %d3,(%a3)+
		dbf       %d7,_ExecCmd_Put_Draw_normal_loop2
_ExecCmd_Put_Draw_normal_loop2_continue:
		moveq.l   #0,%d3
		move.b    (%a0)+,%d3
		lsl.w     %d4,%d3
		or.b      %d3,(%a3)
		lea.l     (%d5.w,%a3),%a3
		dbf       %d0,_ExecCmd_Put_Draw_normal_loop				
		jbra      TokensExec_EndTokenCmd

_ExecCmd_Put_Draw_left:
		neg.w     %d0					|x = -x
		move.w    %d0,%d6
		lsr.w     #3,%d6
		
		move.w    %d6,%d7
		lsl.w     #3,%d7
		cmp.w     %d7,%d0
		jbeq      _ExecCmd_Put_Draw_left_continue
		addi.w    #1,%d6		
_ExecCmd_Put_Draw_left_continue:
		moveq.l   #0,%d0
		move.w    %d3,%d0
		dbf       %d0,_ExecCmd_Put_Draw_left_loop
		jbra      TokensExec_EndTokenCmd
_ExecCmd_Put_Draw_left_loop:
		subq.l    #1,%a0		
		lea.l     (%d6.w,%a0),%a0
		lea.l     (%d6.w,%a3),%a3
		
		moveq.l   #0,%d7
		move.w    %d2,%d7
		sub.w     %d6,%d7
		dbf       %d7,_ExecCmd_Put_Draw_left_loop2
		jbra      _ExecCmd_Put_Draw_left_loop2_continue
_ExecCmd_Put_Draw_left_loop2:
		moveq.l   #0,%d3
		move.b    (%a0)+,%d3
		lsl.w     %d4,%d3
		or.b      %d3,(%a3)
		moveq.l   #0,%d3
		move.b    (%a0),%d3
		lsr.w     %d1,%d3
		or.b      %d3,(%a3)+
		dbf       %d7,_ExecCmd_Put_Draw_left_loop2
_ExecCmd_Put_Draw_left_loop2_continue:
		moveq.l   #0,%d3
		move.b    (%a0)+,%d3
		lsl.w     %d4,%d3
		or.b      %d3,(%a3)
		lea.l     (%d5.w,%a3),%a3
		dbf       %d0,_ExecCmd_Put_Draw_left_loop		
		jbra      TokensExec_EndTokenCmd
		
_ExecCmd_Put_Draw_right:
		subi.w    #MAX_LCD_WIDTH+1,%d6
		asr.w     #3,%d6
		moveq.l   #0,%d0
		move.w    %d3,%d0
		dbf       %d0,_ExecCmd_Put_Draw_right_loop
		jbra      TokensExec_EndTokenCmd
_ExecCmd_Put_Draw_right_loop:
		moveq.l   #0,%d3
		move.b    (%a0),%d3
		lsr.w     %d1,%d3
		or.b      %d3,(%a3)+
		
		moveq.l   #0,%d7
		move.w    %d2,%d7
		sub.w     %d6,%d7
		subq.l    #1,%d7
		dbf       %d7,_ExecCmd_Put_Draw_right_loop2
		jbra      _ExecCmd_Put_Draw_right_loop2_continue
_ExecCmd_Put_Draw_right_loop2:
		moveq.l   #0,%d3
		move.b    (%a0)+,%d3
		lsl.w     %d4,%d3
		or.b      %d3,(%a3)
		moveq.l   #0,%d3
		move.b    (%a0),%d3
		lsr.w     %d1,%d3
		or.b      %d3,(%a3)+
		dbf       %d7,_ExecCmd_Put_Draw_right_loop2
_ExecCmd_Put_Draw_right_loop2_continue:		
		addq.l    #1,%a0
		lea.l     (%d6.w,%a0),%a0
		lea.l     (%d6.w,%a3),%a3
		lea.l     (%d5.w,%a3),%a3
		dbf       %d0,_ExecCmd_Put_Draw_right_loop		
		jbra      TokensExec_EndTokenCmd

_ExecCmd_Put_mode:
		move.b    -35(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     -36(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   -32(%a5),%a0
		move.w    2(%a0),%d4
		jbra      _ExecCmd_Put_continue
		
_ExecCmd_Put_lcd_mem:
		move.b    -47(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     -48(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit		
		
		movea.l   -44(%a5),%a3
		movea.l   (%a3),%a3
		jbra      _ExecCmd_Put_continue2
		
ExecCmd_Put:
		jbsr      TokensExec_CNumArg
		cmpi.w    #5,%d6				|Trop d'arguments
		jbhi      _ERROR_too_arguments
		cmpi.w    #3,%d6				|Pas assez d'arguments
		jbcs      _ERROR_few_arguments
		
		movea.l   ptrEnd_ES(%PC),%a5			|Place la pile au dbut de la premire donnes
		lea.l     -12(%a5),%a5
		
		|Coordonne X
		move.b    1(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     (%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Coordonne Y
		move.b    -11(%a5),%d0
		move.w    #TYPE_INTEGER,%d1
		lea.l     -12(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		|Chane de caractres
		move.b    -24(%a5),%d0				|Oprande
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    -23(%a5),%d0				|Type
		cmpi.b    #TYPE_STRING,%d0
		jbne      _ERROR_types_incompatible
		
		|Mode d'affichage
		move.w    #MODE_OR,%d4
		cmpi.w    #4,%d6
		jbcc      _ExecCmd_Put_mode
_ExecCmd_Put_continue:
		|Zone mmoire
		cmpi.w    #5,%d6
		movea.l   #LCD_MEM,%a3				|Zone mmoire par dfaut
		jbeq      _ExecCmd_Put_lcd_mem
		
_ExecCmd_Put_continue2:
		movea.l   4(%a5),%a0				|X
		move.w    2(%a0),%d0
		movea.l   -8(%a5),%a0				|Y
		move.w    2(%a0),%d1
		
		|Header chane de caractres
		movea.l   -20(%a5),%a0				|Zone chane de caractres
		move.w    (%a0)+,%d2				|Largeur
		move.w    (%a0)+,%d3				|Hauteur
		
		|Bytewidth
		addi.w    #7,%d2
		asr.w     #3,%d2
		jbra      _ExecCmd_Put_Draw
		
|=====|
|POINT|
|=====|		
ExecFnc_Point:
		TokensExec_Func_CheckArg	#2
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    1(%a5),%d0				|Y
		move.w    #TYPE_INTEGER,%d1
		movea.l   %a5,%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		move.b    13(%a5),%d0				|X
		move.w    #TYPE_INTEGER,%d1
		lea.l     12(%a5),%a2
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _Exec_exit
		
		movea.l   4(%a5),%a0
		move.w    2(%a0),-(%SP)
		movea.l   16(%a5),%a0
		move.w    2(%a0),-(%SP)
		ROM_CALL  GetPix
		addq.l    #4,%SP
		tst.w     %d0
		sne       %d0
		jbra      TokensExec_AddResult_Func_Bool

		.end
		