// Header File
// Created 10/08/2004; 14:34:40
#ifndef __H_ERROR
#define __H_ERROR

#define ERROR_NOERROR								0
#define ERROR_SYNTAX								1
#define ERROR_OPENFILE							2
#define ERROR_MEMORY								3
#define ERROR_EXPRSTACK_OVERFLOW		4
#define ERROR_STRING_OVERFLOW				5
#define ERROR_OVERFLOW							6
#define ERROR_EXPR_OVERFLOW					7
#define ERROR_VAR_OVERFLOW					8
#define ERROR_LINETOOLONG						9
#define ERROR_CREATEFILE						10
#define ERROR_NOPARENTH_CLOSE				11
#define ERROR_NOPARENTH_OPEN				12
#define ERROR_LABEL_OVERFLOW				13
#define ERROR_LABEL_DEFINED					14
#define ERROR_LABEL_UNDEFINED				15
#define ERROR_INTERNE_MOVETAGS			16
#define ERROR_TBL_INDICES						17
#define ERROR_TBL_INCORRECT_INDICE	18
#define ERROR_TBL_UNDEF							19
#define ERROR_TBL_DEF								20
#define ERROR_TYPE_INCOMPATIBLE			21
#define ERROR_OPERATION							22
#define ERROR_FEW_ARGUMENT					23
#define ERROR_LOT_ARGUMENT					24
#define ERROR_DIVIDE_BY_ZERO				25
#define ERROR_INCORRECT_ARG					26
#define ERROR_TBL_ZERODIM						27
#define ERROR_NON_REAL_RESULT				28
#define ERROR_GOTO_OVERFLOW					29
#define ERROR_IF_OVERFLOW						30
#define ERROR_ELSE									31
#define ERROR_ENDIF									32
#define ERROR_IF										33
#define ERROR_ELSEIF								34
#define ERROR_ELSEIF_OVERFLOW				35
#define ERROR_DO_OVERFLOW						36
#define ERROR_STRUCT_OVERFLOW				37
#define ERROR_LOOP									38
#define ERROR_DO										39
#define ERROR_EXITIF_OVERFLOW				40
#define ERROR_EXITIF								41
#define ERROR_REPEAT_OVERFLOW				42
#define ERROR_UNTIL									43
#define ERROR_REPEAT								44
#define ERROR_WHILE_OVERFLOW				45
#define ERROR_WEND									46
#define ERROR_WHILE									47
#define ERROR_FOR_OVERFLOW					48
#define ERROR_NEXT									49
#define ERROR_FOR										50
#define ERROR_RESTORE_OVERFLOW			51
#define ERROR_CONTINUE_OVERFLOW			52
#define ERROR_CONTINUE							53		

extern const char *Tbl_Error [];
												 
extern unsigned char error_code;
extern unsigned short error_line;
extern unsigned short error_ptr;

extern void Error_Print (BOOL,BOOL);
#endif