// Header File
// Created 10/08/2004; 15:00:14
#ifndef __H_FILE
#define __H_FILE

#define FILE_TEXT				0x00
#define FILE_TOKENIZED	0x01

#define VERSION_FILE_TOKENS 0x01

#define Get_GFA_TableToken_Command(x)				(unsigned char *)(FileTOKENS+GFA_TableToken_Command [x])
#define Get_GFA_TableToken_Function(x)			(unsigned char *)(FileTOKENS+GFA_TableToken_Function [x])
#define Get_GFA_TableToken_Constant(x)			(unsigned char *)(FileTOKENS+GFA_TableToken_Constant [x])

extern unsigned char GFAFile_name [9];
extern lstring GFAFile;
extern SYM_ENTRY *entry_GFAFile;
extern HANDLE h_GFAFile;
extern unsigned char GFAFile_type;

extern void *FileTOKENS;
extern SYM_ENTRY *entry_fileTOKENS;
extern HANDLE HANDLE_entry_fileTOKENS;

extern unsigned short *GFA_TableToken_Command;
extern unsigned short *GFA_TableToken_Function;
extern unsigned short *GFA_TableToken_Constant;

extern char *File_GenerateTIOSName (const char*, char*);
extern SYM_ENTRY *File_GetSymByName (const char *);
extern char *File_Find (char file[8]);
extern BOOL File_Open (const char *);
extern void File_Close (void);
extern BOOL File_OpenDatas (void);
extern void File_CloseDatas (void);
#endif