// Header File
// Created 10/08/2004; 13:47:10
#ifndef __H_TOKENISOR
#define __H_TOKENISOR

#define MAX_SYMBOL								0xFF
#define MAX_PAGE_TOKENSFILE				50

//Tables des symboles
//-------------------
extern lstring *TSym_float;
extern lstring *TSym_integer;
extern lstring *TSym_bool;
extern lstring *TSym_string;

extern lstring *TSym_tblfloat;
extern lstring *TSym_tblinteger;
extern lstring *TSym_tblbool;
extern lstring *TSym_tblstring;

extern lstring *TSym_label;
extern unsigned char defined_label [MAX_SYMBOL];

extern unsigned short nTSym_float, nTSym_integer, nTSym_bool, nTSym_string;
extern unsigned short nTSym_tblfloat, nTSym_tblinteger, nTSym_tblbool, nTSym_tblstring;
extern unsigned short nTSym_label;


//Gestion criture buffer tokens
//------------------------------
extern unsigned char *TokensFile_buffer;
extern unsigned short TokensFile_size, TokensFile_nbloc;
extern unsigned char *Sav_TokensFile_buffer;
extern unsigned short Sav_TokensFile_size, Sav_TokensFile_nbloc;

extern unsigned char *Data_TokensFile_buffer;
extern unsigned short Data_TokensFile_size, Data_TokensFile_nbloc;
extern unsigned char *iData_TokensFile_buffer;
extern unsigned short iData_TokensFile_size, iData_TokensFile_nbloc;
extern unsigned short iData_Number;


#define Tokenisor_Add(adr,token,size)					({if (!Tokenisor_AddToken(adr,token,size)) return FALSE;})	
extern BOOL Tokenisor_AddToken (void *, unsigned char, unsigned char);
extern BOOL Tokenisor_MakeTokens (void);
extern void Tokenisor_WriteSymbols (lstring *, unsigned char, FILE *);
extern BOOL Tokenisor_MakeFile (unsigned char *file_name);

#endif

