// Header File
// Created 15/08/2004; 19:02:56
#ifndef __H_TOKENSEXEC
#define __H_TOKENSEXEC

typedef void (*Tbl_RunToken)(void);
extern Tbl_RunToken RunToken [];		
		
extern void ExecToken_none (void);
extern void ExecToken_Jump (void);
extern void ExecToken_If (void);
extern void ExecToken_IfJump (void);
extern void ExecToken_Clear (void);
extern void ExecToken_Eofline (void);
extern void ExecToken_Endtag (void);
extern void ExecToken_Pointvirgule (void);
extern void ExecToken_Apost (void);
											 
extern void ExecToken_Number_Float (void);
extern void ExecToken_Number_Int (void);
extern void ExecToken_String (void);
												 
extern void ExecToken_Var_Float (void);
extern void ExecToken_Var_String (void);
extern void ExecToken_Var_Int (void);
extern void ExecToken_Var_Bool (void);

extern void ExecToken_Var_TFloat (void);
extern void ExecToken_Var_TString (void);
extern void ExecToken_Var_TInt (void);
extern void ExecToken_Var_TBool (void);
												 												 
extern void ExecToken_Math_Add (void);
extern void ExecToken_Math_Sub (void);
extern void ExecToken_Math_Mul (void);
extern void ExecToken_Math_Div (void);
extern void ExecToken_Math_Puiss (void);
													 
extern void ExecToken_Compare_Superior (void);
extern void ExecToken_Compare_Inferior (void);
extern void ExecToken_Egal (void);
extern void ExecToken_Supegal (void);
extern void ExecToken_Infegal (void); 
extern void ExecToken_Diff (void);
													 
extern void ExecToken_Affec (void);
													 
extern void ExecToken_Logic_Not (void);
extern void ExecToken_Logic_And (void);
extern void ExecToken_Logic_Or (void);
extern void ExecToken_Logic_Xor (void);
extern void ExecToken_Logic_Imp (void);
extern void ExecToken_Logic_Eqv (void);
extern void ExecToken_Math_Mod (void);
extern void ExecToken_Math_Divint (void);

extern void ExecToken_Negatif (void);

#endif