// Header File
// Created 10/08/2004; 18:11:43
#ifndef __H_TBL_FUNCS
#define __H_TBL_FUNCS
																									
const unsigned char GFA_TableCalc [24] = {
	SUBTAG_LOGIC,		//AND
	SUBTAG_LOGIC,		//OR
	SUBTAG_LOGIC,		//XOR
	SUBTAG_LOGIC,		//IMP
	SUBTAG_LOGIC,		//EQV
	SUBTAG_SUB,			// -
	SUBTAG_ADD,			// +
	SUBTAG_MUL,			// *
	SUBTAG_DIV,			// /
	SUBTAG_PUISS,		// ^
	SUBTAG_MOD,			//MOD
	SUBTAG_LOGIC,		//NOT
	SUBTAG_DIVINT,	//DIV
	SUBTAG_DIFF,		//<>
	SUBTAG_INFEGAL,	//<=
	SUBTAG_INFEGAL,	//=<
	SUBTAG_SUPEGAL,	//>=
	SUBTAG_SUPEGAL,	//=>
	SUBTAG_INFERIOR,//<
	SUBTAG_SUPERIOR,//>
	SUBTAG_EGAL,		//=
	SUBTAG_INFEGAL,	//<=
	SUBTAG_SUPEGAL,	//>=
	SUBTAG_DIFF			//<>
};


//Tokens d'execution Command:
//***************************
const unsigned char GFA_TableExecToken_Command [0x100] = {
	ETOKEN_NONE,											//0x00
	ETOKEN_NONE,											//0x01
	ETOKEN_NONE,											//0x02
	ETOKEN_NONE,											//0x03
	ETOKEN_NONE,											//0x04
	ETOKEN_NONE,											//0x05
	ETOKEN_NONE,											//0x06
	ETOKEN_NONE,											//0x07
	ETOKEN_NONE,											//0x08
	ETOKEN_NONE,											//0x09
	ETOKEN_NONE,											//0x0A
	ETOKEN_NONE,											//0x0B
	ETOKEN_NONE,											//0x0C
	ETOKEN_NONE,											//0x0D
	ETOKEN_FUNC_PRINT, 								//0x0E
	ETOKEN_NONE,											//0x0F
	ETOKEN_NONE,											//0x10
	ETOKEN_FUNC_POKE,									//0x11
	ETOKEN_FUNC_DPOKE,								//0x12
	ETOKEN_FUNC_LPOKE,								//0x13
	ETOKEN_NONE,											//0x14
	ETOKEN_FUNC_SYSTEM,								//0x15
	ETOKEN_NONE,											//0x16
	ETOKEN_NONE,											//0x17
	ETOKEN_NONE,											//0x18
	ETOKEN_NONE,											//0x19
	ETOKEN_FUNC_BOX,									//0x1A
	ETOKEN_NONE,											//0x1B
	ETOKEN_NONE,											//0x1C
	ETOKEN_NONE,											//0x1D
	ETOKEN_FUNC_PLOT,									//0x1E
	ETOKEN_FUNC_LINE,									//0x1F
	ETOKEN_NONE,											//0x20
	ETOKEN_NONE,											//0x21
	ETOKEN_FUNC_SETFONT,							//0x22
	ETOKEN_NONE,											//0x23
	ETOKEN_NONE,											//0x24
	ETOKEN_NONE,											//0x25
	ETOKEN_NONE,											//0x26
	ETOKEN_FUNC_TEXT,									//0x27
	ETOKEN_NONE,											//0x28
	ETOKEN_NONE,											//0x29
	ETOKEN_FUNC_DIM,									//0x2A
	ETOKEN_NONE,											//0x2B
	ETOKEN_NONE,											//0x2C
	ETOKEN_NONE,											//0x2D
	ETOKEN_NONE,											//0x2E
	ETOKEN_NONE,											//0x2F
	ETOKEN_FUNC_ADD,									//0x30
	ETOKEN_FUNC_SUB,									//0x31
	ETOKEN_FUNC_MUL,									//0x32
	ETOKEN_FUNC_DIV,									//0x33
	ETOKEN_FUNC_INC,									//0x34
	ETOKEN_FUNC_DEC,									//0x35
	ETOKEN_NONE,											//0x36
	ETOKEN_NONE,											//0x37
	ETOKEN_NONE,											//0x38
	ETOKEN_NONE,											//0x39
	ETOKEN_FUNC_INPUT,								//0x3A
	ETOKEN_NONE,											//0x3B
	ETOKEN_NONE,											//0x3C
	ETOKEN_NONE,											//0x3D
	ETOKEN_NONE,											//0x3E
	ETOKEN_NONE,											//0x3F
	ETOKEN_NONE,											//0x40
	ETOKEN_NONE,											//0x41
	ETOKEN_NONE,											//0x42
	ETOKEN_NONE,											//0x43
	ETOKEN_NONE,											//0x44
	ETOKEN_NONE,											//0x45
	ETOKEN_FUNC_CLR,									//0x46
	ETOKEN_NONE,											//0x47
	ETOKEN_FUNC_SWAP,									//0x48
	ETOKEN_NONE,											//0x49
	ETOKEN_FUNC_ARRAYFILL,						//0x4A
	ETOKEN_NONE,											//0x4B
	ETOKEN_NONE,											//0x4C
	ETOKEN_NONE,											//0x4D
	ETOKEN_NONE,											//0x4E
	ETOKEN_NONE,											//0x4F
	ETOKEN_NONE,											//0x50
	ETOKEN_FUNC_READ,									//0x51
	ETOKEN_NONE,											//0x52
	ETOKEN_NONE,											//0x53
	ETOKEN_NONE,											//0x54
	ETOKEN_NONE,											//0x55
	ETOKEN_NONE,											//0x56
	ETOKEN_NONE,											//0x57
	ETOKEN_NONE,											//0x58
	ETOKEN_FUNC_CLS,									//0x59
	ETOKEN_NONE,											//0x5A
	ETOKEN_NONE,											//0x5B
	ETOKEN_NONE,											//0x5C
	ETOKEN_NONE,											//0x5D
	ETOKEN_NONE,											//0x5E
	ETOKEN_NONE,											//0x5F
	ETOKEN_FUNC_SYSTEM,								//0x60
	ETOKEN_NONE,											//0x61
	ETOKEN_NONE,											//0x62
	ETOKEN_NONE,											//0x63
	ETOKEN_NONE,											//0x64
	ETOKEN_NONE,											//0x65
	ETOKEN_NONE,											//0x66
	ETOKEN_NONE,											//0x67
	ETOKEN_NONE,											//0x68
	ETOKEN_NONE,											//0x69
	ETOKEN_FUNC_CLR,									//0x6A
	ETOKEN_NONE,											//0x6B
	ETOKEN_NONE,											//0x6C
	ETOKEN_NONE,											//0x6D
	ETOKEN_NONE,											//0x6E
	ETOKEN_NONE,											//0x6F
	ETOKEN_FUNC_RUN,									//0x70
	ETOKEN_FUNC_END,									//0x71
	ETOKEN_FUNC_END,									//0x72		
	ETOKEN_NONE,											//0x73
	ETOKEN_NONE,											//0x74
	ETOKEN_NONE,											//0x75
	ETOKEN_NONE,											//0x76
	ETOKEN_NONE,											//0x77
	ETOKEN_NONE,											//0x78		
	ETOKEN_NONE,											//0x79
	ETOKEN_NONE,											//0x7A
	ETOKEN_FUNC_PAUSE,								//0x7B
	ETOKEN_NONE,											//0x7C
	ETOKEN_NONE,											//0x7D
	ETOKEN_FUNC_SPRITE,								//0x7E		
	ETOKEN_NONE,											//0x7F
	ETOKEN_NONE,											//0x80
	ETOKEN_FUNC_GET,									//0x81
	ETOKEN_NONE,											//0x82
	ETOKEN_FUNC_PUT,									//0x83
	ETOKEN_NONE,											//0x84		
	ETOKEN_NONE,											//0x85
	ETOKEN_NONE,											//0x86
	ETOKEN_NONE,											//0x87
	ETOKEN_FUNC_SYSTEM,								//0x88
	ETOKEN_NONE,											//0x89
	ETOKEN_NONE,											//0x8A		
	ETOKEN_NONE,											//0x8B
	ETOKEN_NONE,											//0x8C
	ETOKEN_NONE,											//0x8D
	ETOKEN_NONE,											//0x8E
	ETOKEN_NONE,											//0x8F
	ETOKEN_NONE,											//0x90		
	ETOKEN_NONE,											//0x91
	ETOKEN_NONE,											//0x92
	ETOKEN_NONE,											//0x93
	ETOKEN_NONE,											//0x94
	ETOKEN_NONE,											//0x95
	ETOKEN_NONE,											//0x96		
	ETOKEN_NONE,											//0x97
	ETOKEN_NONE,											//0x98
	ETOKEN_NONE,											//0x99
	ETOKEN_NONE,											//0x9A
	ETOKEN_NONE,											//0x9B
	ETOKEN_NONE,											//0x9C		
	ETOKEN_NONE,											//0x9D
	ETOKEN_NONE,											//0x9E
	ETOKEN_NONE,											//0x9F
	ETOKEN_NONE,											//0xA0
	ETOKEN_NONE,											//0xA1
	ETOKEN_NONE,											//0xA2		
	ETOKEN_NONE,											//0xA3
	ETOKEN_NONE,											//0xA4
	ETOKEN_NONE,											//0xA5
	ETOKEN_NONE,											//0xA6
	ETOKEN_NONE,											//0xA7
	ETOKEN_NONE,											//0xA8		
	ETOKEN_NONE,											//0xA9
	ETOKEN_NONE,											//0xAA
	ETOKEN_NONE,											//0xAB
	ETOKEN_NONE,											//0xAC
	ETOKEN_NONE,											//0xAD
	ETOKEN_NONE,											//0xAE		
	ETOKEN_NONE,											//0xAF
	ETOKEN_NONE,											//0xB0
	ETOKEN_NONE,											//0xB1
	ETOKEN_NONE,											//0xB2
	ETOKEN_NONE,											//0xB3
	ETOKEN_NONE,											//0xB4		
	ETOKEN_NONE,											//0xB5
	ETOKEN_NONE,											//0xB6
	ETOKEN_NONE,											//0xB7
	ETOKEN_NONE,											//0xB8
	ETOKEN_NONE,											//0xB9
	ETOKEN_NONE,											//0xBA
	ETOKEN_NONE,											//0xBB		
	ETOKEN_NONE,											//0xBC		
	ETOKEN_NONE,											//0xBD		
	ETOKEN_NONE,											//0xBE		
	ETOKEN_NONE,											//0xBF		
	ETOKEN_NONE,											//0xC0		
	ETOKEN_NONE,											//0xC1		
	ETOKEN_NONE,											//0xC2
	ETOKEN_NONE,											//0xC3
	ETOKEN_NONE,											//0xC4		
	ETOKEN_NONE,											//0xC5		
	ETOKEN_NONE,											//0xC6		
	ETOKEN_NONE,											//0xC7		
	ETOKEN_NONE,											//0xC8		
	ETOKEN_NONE,											//0xC9		
	ETOKEN_NONE,											//0xCA		
	ETOKEN_NONE,											//0xCB	
	ETOKEN_NONE,											//0xCC
	ETOKEN_NONE,											//0xCD		
	ETOKEN_NONE,											//0xCE		
	ETOKEN_NONE,											//0xCF		
	ETOKEN_NONE,											//0xD0		
	ETOKEN_NONE,											//0xD1		
	ETOKEN_NONE,											//0xD2		
	ETOKEN_NONE,											//0xD3		
	ETOKEN_NONE,											//0xD4
	ETOKEN_NONE,											//0xD5
	ETOKEN_NONE,											//0xD6
	ETOKEN_NONE,											//0xD7
	ETOKEN_NONE,											//0xD8
	ETOKEN_NONE,											//0xD9
	ETOKEN_NONE,											//0xDA
	ETOKEN_NONE,											//0xDB
	ETOKEN_NONE,											//0xDC
	ETOKEN_NONE,											//0xDD
	ETOKEN_NONE,											//0xDE
	ETOKEN_NONE,											//0xDF
	ETOKEN_NONE,											//0xE0
	ETOKEN_NONE,											//0xE1
	ETOKEN_NONE,											//0xE2
	ETOKEN_NONE,											//0xE3
	ETOKEN_NONE,											//0xE4
	ETOKEN_NONE,											//0xE5	
	ETOKEN_NONE,											//0xE6
	ETOKEN_NONE,											//0xE7
	ETOKEN_NONE,											//0xE8
	ETOKEN_NONE,											//0xE9
	ETOKEN_NONE,											//0xEA
	ETOKEN_NONE,											//0xEB
	ETOKEN_NONE,											//0xEC
	ETOKEN_NONE,											//0xED
	ETOKEN_NONE,											//0xEE
	ETOKEN_NONE,											//0xEF
	ETOKEN_NONE,											//0xF0
	ETOKEN_NONE,											//0xF1
	ETOKEN_NONE,											//0xF2
	ETOKEN_NONE,											//0xF3
	ETOKEN_NONE,											//0xF4
	ETOKEN_NONE,											//0xF5
	ETOKEN_NONE,											//0xF6
	ETOKEN_NONE,											//0xF7
	ETOKEN_NONE,											//0xF8
	ETOKEN_NONE,											//0xF9
	ETOKEN_NONE,											//0xFA
	ETOKEN_NONE,											//0xFB
	ETOKEN_NONE,											//0xFC
	ETOKEN_NONE,											//0xFD		
	ETOKEN_NONE,											//0xFE
	ETOKEN_NONE												//0xFF			
};


//Tokens d'execution Command:
//***************************
const unsigned char GFA_TableExecToken_Function [0x100] = {
	ETOKEN_LOGIC_AND,									//0x00
	ETOKEN_LOGIC_OR,									//0x01
	ETOKEN_LOGIC_XOR,									//0x02
	ETOKEN_LOGIC_IMP,									//0x03
	ETOKEN_LOGIC_EQV,									//0x04
	ETOKEN_MATH_SUB,									//0x05
	ETOKEN_MATH_ADD,									//0x06
	ETOKEN_MATH_MUL,									//0x07
	ETOKEN_MATH_DIV,									//0x08
	ETOKEN_MATH_PUISS,								//0x09
	ETOKEN_MATH_MOD,									//0x0A
	ETOKEN_LOGIC_NOT,									//0x0B
	ETOKEN_MATH_DIVINT,								//0x0C
	ETOKEN_COMPARE_DIFF,							//0x0D		//Nombres
	ETOKEN_COMPARE_INFEGAL,						//0x0E
	ETOKEN_COMPARE_INFEGAL,						//0x0F
	ETOKEN_COMPARE_SUPEGAL,						//0x10
	ETOKEN_COMPARE_SUPEGAL,						//0x11
	ETOKEN_COMPARE_INFERIOR,					//0x12
	ETOKEN_COMPARE_SUPERIOR,					//0x13
	ETOKEN_COMPARE_EGAL,							//0x14
	ETOKEN_COMPARE_INFEGAL,						//0x15		
	ETOKEN_COMPARE_SUPEGAL,						//0x16
	ETOKEN_COMPARE_DIFF,							//0x17
	ETOKEN_NONE,											//0x18		//Chanes de caractres
	ETOKEN_FUNC_SQR,									//0x19
	ETOKEN_FUNC_EXP,									//0x1A
	ETOKEN_NONE,											//0x1B
	ETOKEN_NONE,											//0x1C
	ETOKEN_NONE,											//0x1D
	ETOKEN_NEGATIF,										//0x1E
	ETOKEN_NONE,											//0x1F
	ETOKEN_NONE,											//0x20
	ETOKEN_NONE,											//0x21
	ETOKEN_POINT_VIRGULE,							//0x22
	ETOKEN_NONE,											//0x23
	ETOKEN_FUNC_SGN,									//0x24
	ETOKEN_FUNC_FIX,									//0x25
	ETOKEN_FUNC_FIX,									//0x26
	ETOKEN_FUNC_FRAC,									//0x27
	ETOKEN_FUNC_ABS,									//0x28
	ETOKEN_FUNC_SIN,									//0x29
	ETOKEN_FUNC_COS,									//0x2A
	ETOKEN_FUNC_TAN,									//0x2B
	ETOKEN_FUNC_ATN,									//0x2C
	ETOKEN_APOST,											//0x2D
	ETOKEN_FUNC_ROUND,								//0x2E
	ETOKEN_FUNC_EXP,									//0x2F
	ETOKEN_FUNC_LOG,									//0x30
	ETOKEN_FUNC_LOG10,								//0x31
	ETOKEN_FUNC_PEEK,									//0x32
	ETOKEN_FUNC_DPEEK,								//0x33
	ETOKEN_FUNC_LPEEK,								//0x34
	ETOKEN_FUNC_VAL,									//0x35
	ETOKEN_FUNC_LEN,									//0x36
	ETOKEN_FUNC_ASC,									//0x37
	ETOKEN_NONE,											//0x38
	ETOKEN_FUNC_TIMER,								//0x39
	ETOKEN_FUNC_LEFT,									//0x3A
	ETOKEN_NONE,											//0x3B
	ETOKEN_FUNC_RIGHT,								//0x3C
	ETOKEN_NONE,											//0x3D
	ETOKEN_FUNC_MID,									//0x3E
	ETOKEN_NONE,											//0x3F
	ETOKEN_NONE,											//0x40
	ETOKEN_FUNC_STR,									//0x41
	ETOKEN_FUNC_CHR,									//0x42
	ETOKEN_NONE,											//0x43
	ETOKEN_NONE,											//0x44
	ETOKEN_AFFEC,											//0x45
	ETOKEN_FUNC_GETFONT,							//0x46
	ETOKEN_NONE,											//0x47
	ETOKEN_NONE,											//0x48
	ETOKEN_NONE,											//0x49
	ETOKEN_NONE,											//0x4A
	ETOKEN_NONE,											//0x4B
	ETOKEN_NONE,											//0x4C
	ETOKEN_NONE,											//0x4D
	ETOKEN_FUNC_SQR,									//0x4E
	ETOKEN_NONE,											//0x4F
	ETOKEN_NONE,											//0x50
	ETOKEN_NONE,											//0x51
	ETOKEN_NONE,											//0x52
	ETOKEN_FUNC_GETKEY,								//0x53
	ETOKEN_NONE,											//0x54
	ETOKEN_FUNC_RND,									//0x55
	ETOKEN_FUNC_RANDOM,								//0x56
	ETOKEN_NONE,											//0x57
	ETOKEN_FUNC_FRE,									//0x58
	ETOKEN_FUNC_AT,										//0x59
	ETOKEN_NONE,											//0x5A
	ETOKEN_MATH_DIVINT,								//0x5B
	ETOKEN_FUNC_POINT,								//0x5C
	ETOKEN_FUNC_LVAL,									//0x5D
	ETOKEN_NONE,											//0x5E
	ETOKEN_NONE,											//0x5F
	ETOKEN_NONE,											//0x60
	ETOKEN_FUNC_NGETCHX,							//0x61
	ETOKEN_FUNC_MKI,									//0x62
	ETOKEN_FUNC_MKL,									//0x63
	ETOKEN_FUNC_MKF,									//0x64
	ETOKEN_FUNC_CVI,									//0x65
	ETOKEN_FUNC_CVL,									//0x66
	ETOKEN_FUNC_CVF,									//0x67
	ETOKEN_NONE,											//0x68
	ETOKEN_NONE,											//0x69
	ETOKEN_NONE,											//0x6A
	ETOKEN_NONE,											//0x6B
	ETOKEN_NONE,											//0x6C
	ETOKEN_NONE,											//0x6D
	ETOKEN_FUNC_HEX,									//0x6E
	ETOKEN_FUNC_OCT,									//0x6F
	ETOKEN_FUNC_BIN,									//0x70
	ETOKEN_NONE,											//0x71
	ETOKEN_NONE,											//0x72		
	ETOKEN_NONE,											//0x73
	ETOKEN_NONE,											//0x74
	ETOKEN_NONE,											//0x75
	ETOKEN_NONE,											//0x76
	ETOKEN_NONE,											//0x77
	ETOKEN_NONE,											//0x78		
	ETOKEN_NONE,											//0x79
	ETOKEN_FUNC_VARPTR,								//0x7A
	ETOKEN_FUNC_ARRPTR,								//0x7B
	ETOKEN_NONE,											//0x7C
	ETOKEN_FUNC_LDIM,									//0x7D
	ETOKEN_NONE,											//0x7E		
	ETOKEN_FUNC_UPPER,								//0x7F
	ETOKEN_FUNC_SPACE,								//0x80
	ETOKEN_FUNC_STRING,								//0x81
	ETOKEN_FUNC_LOWER,								//0x82
	ETOKEN_NONE,											//0x83
	ETOKEN_NONE,											//0x84		
	ETOKEN_FUNC_DFREE,								//0x85
	ETOKEN_NONE,											//0x86
	ETOKEN_NONE,											//0x87
	ETOKEN_NONE,											//0x88
	ETOKEN_NONE,											//0x89
	ETOKEN_NONE,											//0x8A		
	ETOKEN_NONE,											//0x8B
	ETOKEN_NONE,											//0x8C
	ETOKEN_NONE,											//0x8D
	ETOKEN_NONE,											//0x8E
	ETOKEN_NONE,											//0x8F
	ETOKEN_NONE,											//0x90		
	ETOKEN_NONE,											//0x91
	ETOKEN_NONE,											//0x92
	ETOKEN_NONE,											//0x93
	ETOKEN_NONE,											//0x94
	ETOKEN_NONE,											//0x95
	ETOKEN_NONE,											//0x96		
	ETOKEN_NONE,											//0x97
	ETOKEN_NONE,											//0x98
	ETOKEN_NONE,											//0x99
	ETOKEN_NONE,											//0x9A
	ETOKEN_FUNC_FIX,									//0x9B
	ETOKEN_NONE,											//0x9C		
	ETOKEN_NONE,											//0x9D
	ETOKEN_NONE,											//0x9E
	ETOKEN_NONE,											//0x9F
	ETOKEN_NONE,											//0xA0
	ETOKEN_NONE,											//0xA1
	ETOKEN_NONE,											//0xA2		
	ETOKEN_NONE,											//0xA3
	ETOKEN_NONE,											//0xA4
	ETOKEN_NONE,											//0xA5
	ETOKEN_NONE,											//0xA6
	ETOKEN_NONE,											//0xA7
	ETOKEN_NONE,											//0xA8		
	ETOKEN_NONE,											//0xA9
	ETOKEN_NONE,											//0xAA
	ETOKEN_NONE,											//0xAB
	ETOKEN_NONE,											//0xAC
	ETOKEN_NONE,											//0xAD
	ETOKEN_NONE,											//0xAE		
	ETOKEN_NONE,											//0xAF
	ETOKEN_NONE,											//0xB0
	ETOKEN_NONE,											//0xB1
	ETOKEN_NONE,											//0xB2
	ETOKEN_FUNC_EVEN,									//0xB3
	ETOKEN_FUNC_ODD,									//0xB4		
	ETOKEN_NONE,											//0xB5
	ETOKEN_NONE,											//0xB6
	ETOKEN_NONE,											//0xB7
	ETOKEN_NONE,											//0xB8
	ETOKEN_FUNC_CRSLIN,								//0xB9
	ETOKEN_FUNC_CRSCOL,								//0xBA
	ETOKEN_NONE,											//0xBB		
	ETOKEN_NONE,											//0xBC		
	ETOKEN_NONE,											//0xBD		
	ETOKEN_NONE,											//0xBE		
	ETOKEN_NONE,											//0xBF		
	ETOKEN_NONE,											//0xC0		
	ETOKEN_NONE,											//0xC1		
	ETOKEN_NONE,											//0xC2
	ETOKEN_FUNC_TYPE,									//0xC3
	ETOKEN_NONE,											//0xC4		
	ETOKEN_NONE,											//0xC5		
	ETOKEN_NONE,											//0xC6		
	ETOKEN_NONE,											//0xC7		
	ETOKEN_NONE,											//0xC8		
	ETOKEN_NONE,											//0xC9		
	ETOKEN_NONE,											//0xCA		
	ETOKEN_NONE,											//0xCB	
	ETOKEN_NONE,											//0xCC
	ETOKEN_NONE,											//0xCD		
	ETOKEN_NONE,											//0xCE		
	ETOKEN_NONE,											//0xCF		
	ETOKEN_NONE,											//0xD0		
	ETOKEN_NONE,											//0xD1		
	ETOKEN_NONE,											//0xD2		
	ETOKEN_NONE,											//0xD3		
	ETOKEN_NONE,											//0xD4
	ETOKEN_NONE,											//0xD5
	ETOKEN_NONE,											//0xD6
	ETOKEN_NONE,											//0xD7
	ETOKEN_NONE,											//0xD8
	ETOKEN_NONE,											//0xD9
	ETOKEN_NONE,											//0xDA
	ETOKEN_NONE,											//0xDB
	ETOKEN_NONE,											//0xDC
	ETOKEN_NONE,											//0xDD
	ETOKEN_NONE,											//0xDE
	ETOKEN_NONE,											//0xDF
	ETOKEN_NONE,											//0xE0
	ETOKEN_NONE,											//0xE1
	ETOKEN_NONE,											//0xE2
	ETOKEN_NONE,											//0xE3
	ETOKEN_NONE,											//0xE4
	ETOKEN_NONE,											//0xE5	
	ETOKEN_NONE,											//0xE6
	ETOKEN_NONE,											//0xE7
	ETOKEN_NONE,											//0xE8
	ETOKEN_NONE,											//0xE9
	ETOKEN_NONE,											//0xEA
	ETOKEN_NONE,											//0xEB
	ETOKEN_NONE,											//0xEC
	ETOKEN_NONE,											//0xED
	ETOKEN_NONE,											//0xEE
	ETOKEN_NONE,											//0xEF
	ETOKEN_NONE,											//0xF0
	ETOKEN_NONE,											//0xF1
	ETOKEN_NONE,											//0xF2
	ETOKEN_NONE,											//0xF3
	ETOKEN_NONE,											//0xF4
	ETOKEN_NONE,											//0xF5
	ETOKEN_NONE,											//0xF6
	ETOKEN_NONE,											//0xF7
	ETOKEN_NONE,											//0xF8
	ETOKEN_NONE,											//0xF9
	ETOKEN_NONE,											//0xFA
	ETOKEN_NONE,											//0xFB
	ETOKEN_NONE,											//0xFC
	ETOKEN_NONE,											//0xFD		
	ETOKEN_NONE,											//0xFE
	ETOKEN_NONE												//0xFF			
};


//Tokens de constantes
//********************
const long GFA_TableExecToken_Constant [0x80] = {
	0x4C00,														//LCD_MEM
	3840,															//LCD_SIZE
	344,															//KEY_DOWN
	338,															//KEY_UP
	337,															//KEY_LEFT
	340,															//KEY_RIGHT
	268,															//KEY_F1
	269,															//KEY_F2
	270,															//KEY_F3
	271,															//KEY_F4
	272,															//KEY_F5
	273,															//KEY_F6
	274,															//KEY_F7
	275,															//KEY_F8
	264,															//KEY_ESC
	265,															//KEY_APPS
	13,																//KEY_ENTER
	0,																//F_4x6
	1,																//F_6x8
	2,																//F_8x10
};

const char GFA_TableHexa [16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};

#endif