| Assembly Source File
| Created 24/08/2004, 13:36:53
| C prototype: unsigned short _kb_getkey ();

     xdef    _kb_getkey

_kb_getkey:     
     movem.l  %d1-%d4,-(%SP)
     move.w   CALCULATOR(%PC),%d4
     moveq.l  #0,%d0
     moveq.l  #0,%d1
     
     lea.l    _kb_key_masks(%PC),%a0	|Masque de column
     move.l   #8,%d2			|TI92+/V200
     tst.b    %d4			|Test calculatrice
     jbne    _kb_getkey_loop_row
     move.l   #5,%d2			|TI89
     addq.l   #6,%a0
_kb_getkey_loop_row:
     move.w   (%a0)+,0x600018
     nop
     nop
     nop
     nop
     nop
     nop
     lsr.l    #6,%d1
     lsr.l    #6,%d1
     move.b   0x60001B,%d1
     moveq.l  #7,%d3 			|compteur de col 
_kb_getkey_loop_col:
     lsr.b    #1,%d1
     jbcc     _kb_getkey_lastrow 	|on quitte si detection d'une touche
     addq.l   #1,%d0
     dbra     %d3,_kb_getkey_loop_col 	|fin de boucle col
     dbra     %d2,_kb_getkey_loop_row 	|fin de boucle row
_kb_getkey_lastrow:
     move.w   #0xFFFE,0x600018 		|masque du bit 0     
     nop
     nop
     nop
     nop
     nop
     nop
     lsr.w    #6,%d1
     lsr.w    #6,%d1
     move.b   0x60001B,%d1 		|on recupere la row
     move.b   %d1,%d2
     |Dtection calculatrice pour layout
     tst.b    %d4
     jbne     _kb_calc92_retval		|TI92+
          	
|Layout TI89     
_kb_calc89_retval:
     cmpi.w   #48,%d0
     jbne    _kb_calc89_endarrows
|lecture des flches
     lsr.b    #1,%d1
     jbcc     _kb_calc89_endarrows 	|on quitte si detection d'une touche
     addq.l   #1,%d0 			|on incremente d0 (index)
     lsr.b    #1,%d1
     jbcc     _kb_calc89_endarrows 	|on quitte si detection d'une touche
     addq.l   #1,%d0 			|on incremente d0 (index)
     lsr.b    #1,%d1
     jbcc     _kb_calc89_endarrows 	|on quitte si detection d'une touche
     addq.l   #1,%d0 			|on incremente d0 (index)
     lsr.b    #1,%d1
     jbcc     _kb_calc89_endarrows 	|on quitte si detection d'une touche
|quitte avec 0 si aucune touche n'est presse
     moveq.l  #0,%d0
     movem.l  (%SP)+,%d1-%d4
     rts
     
_kb_calc89_endarrows:	
     lsl.b    #1,%d2
     jbcc     _kb_calc89_alpha
     lsl.b    #1,%d2
     jbcc     _kb_calc89_diamond
     lsl.b    #1,%d2
     jbcc     _kb_calc89_shift
     lsl.b    #1,%d2
     jbcc     _kb_calc89_2nd
     lea.l    _kb_key_data_89_normal(%PC),%a0
     jbra     _kb_return
_kb_calc89_shift:
     lea.l    _kb_key_data_89_shift(%PC),%a0
     jbra     _kb_return 
_kb_calc89_alpha:
     lea.l    _kb_key_data_89_alpha(%PC),%a0
     jbra     _kb_return     
_kb_calc89_2nd:
     lea.l    _kb_key_data_89_2nd(%PC),%a0
     jbra     _kb_return     
_kb_calc89_diamond:
     lea.l    _kb_key_data_89_diamond(%PC),%a0
     jbra     _kb_return

|Layout TI92+/V200     
_kb_calc92_retval:
     cmpi.w   #72,%d0
     jbne     _kb_calc92_endarrows
|lecture des flches
     lsl.b    #1,%d1
     jbcc     _kb_calc92_endarrows 	|on quitte si detection d'une touche
     addq.l   #1,%d0 			|on incremente d0 (index)
     lsl.b    #1,%d1
     jbcc     _kb_calc92_endarrows 	|on quitte si detection d'une touche
     addq.l   #1,%d0 			|on incremente d0 (index)
     lsl.b    #1,%d1
     jbcc     _kb_calc92_endarrows 	|on quitte si detection d'une touche
     addq.l   #1,%d0 			|on incremente d0 (index)
     lsl.b    #1,%d1
     jbcc     _kb_calc92_endarrows 	|on quitte si detection d'une touche
|quitte avec 0 si aucune touche n'est presse
     moveq.l  #0,%d0
     movem.l  (%SP)+,%d1-%d4
     rts	

_kb_calc92_endarrows:
|lecture des stat keys
     lsr.b    #1,%d2
     jbcc     _kb_92P_V200_2nd
     lsr.b    #1,%d2
     jbcc     _kb_92P_V200_diamond
     lsr.b    #1,%d2
     jbcc     _kb_92P_V200_shift
     lsr.b    #1,%d2
     jbcc     _kb_92P_V200_lock     
     lea.l    _kb_key_data_92P_V200_normal(%PC),%a0
     jbra     _kb_return
          
_kb_92P_V200_shift:
     lea.l    _kb_key_data_92P_V200_shift(%PC),%a0
     jbra     _kb_return
_kb_92P_V200_2nd:
     lea.l    _kb_key_data_92P_V200_2nd(%PC),%a0
     jbra     _kb_return     
_kb_92P_V200_diamond:
     lea.l    _kb_key_data_92P_V200_diamond(%PC),%a0
     jbra     _kb_return    
_kb_92P_V200_lock:
     lea.l    _kb_key_data_92P_V200_lock(%PC),%a0   
 
_kb_return:
     add.w    %d0,%d0
     add.w    %d0,%a0
     move.w   (%a0),%d0
_kb_end:
     movem.l  (%SP)+,%d1-%d4
     rts          
 
|;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
|; donnes
|masques prcalculs
_kb_key_masks:
     .word    0xFDFF,0xFEFF,0xFF7F,0xFFBF,0xFFDF,0xFFEF,0xFFF7,0xFFFB,0xFFFD
     
|codes de touches
_kb_key_data_92P_V200_normal:
     .word    45,13,97,113,271,48,46,173
     .word    257,136,108,111,43,266,264,0
     .word    61,109,107,105,272,263,265,42
     .word    94,110,106,117,268,262,13,112
     .word    47,98,104,121,273,259,260,261
     .word    32,118,103,116,269,40,41,44
     .word    258,99,102,114,274,55,56,57
     .word    0,120,100,101,270,52,53,54
     .word    0,122,115,119,275,49,50,51
     .word    344,340,338,337

_kb_key_data_92P_V200_shift:
     .word    45,13,65,81,271,48,46,173
     .word    257,136,76,79,43,266,264,0
     .word    61,77,75,73,272,263,265,42
     .word    94,78,74,85,268,262,13,80
     .word    47,66,72,89,273,259,260,261
     .word    32,86,71,84,269,40,41,44
     .word    258,67,70,82,274,55,56,57
     .word    0,88,68,69,270,52,53,54
     .word    0,90,83,87,275,49,50,51
     .word    33112,33108,33106,33105
     
_kb_key_data_92P_V200_2nd:
     .word    4141,4109,0,63,271,60,62,4372
     .word    4353,58,34,0,4139,266,4360,0
     .word    92,59,124,151,272,263,4361,4138
     .word    140,0,190,0,268,4358,4109,95
     .word    93,39,38,18,273,4355,4356,4357
     .word    32,157,0,35,269,123,125,91
     .word    4354,0,159,64,274,4151,4152,4153
     .word    0,169,176,0,270,4148,4149,4150
     .word    0,0,223,33,275,149,4146,4147
     .word    4440,4436,4434,4433
     
_kb_key_data_92P_V200_diamond:
     .word    0,8205,8257,8273,8463,8240,8238,8365
     .word    8449,8328,8268,8271,0,8458,8456,0
     .word    8253,8269,8267,8265,8464,8455,8457,8234
     .word    8286,8270,8266,8277,8460,8454,8205,8272
     .word    8239,8258,8264,8281,8465,8451,8452,8453
     .word    8224,8278,8263,8276,8461,8232,8233,8236
     .word    8450,8259,8262,8274,8466,8247,8248,8249
     .word    0,8280,8260,8261,8462,8244,8245,8246
     .word    0,8282,8275,8279,8467,8241,8242,8243
     .word    8536,8532,8530,8529
     
_kb_key_data_92P_V200_lock:
     .word    0,0,0,0,0,0,0,0
     .word    0,0,0,0,0,0,0,0
     .word    0,0,0,0,0,0,0,0
     .word    0,0,0,0,0,0,0,0
     .word    0,0,0,0,0,0,0,0
     .word    0,0,0,0,0,0,0,0
     .word    0,0,0,0,0,0,0,0
     .word    0,0,0,0,0,0,0,0
     .word    0,0,0,0,0,0,0,0
     .word    33112,33108,33106,33105
 
 
_kb_key_data_89_normal:
     .word    264,0,0,0,0,0,0,0
     .word    265,258,149,124,61,120,277,268
     .word    48,49,52,55,40,121,266,269
     .word    46,50,53,56,41,122,278,270
     .word    173,51,54,57,44,116,257,271
     .word    13,43,45,42,47,94,263,272
     .word    338,337,344,340
 
_kb_key_data_89_shift:
     .word    264,0,0,0,0,0,0,0
     .word    265,80,75,70,65,88,277,268
     .word    86,81,76,71,66,89,266,269
     .word    87,82,77,72,67,90,278,270
     .word    32,83,78,73,68,84,257,271
     .word    13,85,79,74,69,94,263,272
     .word    16722,16721,16728,16724	 
     
_kb_key_data_89_alpha:
     .word    264,0,0,0,0,0,0,0
     .word    265,112,107,102,97,120,277,268
     .word    118,113,108,103,98,121,266,269
     .word    119,114,109,104,99,122,278,270
     .word    32,115,110,105,100,116,257,271
     .word    13,117,111,106,101,94,263,272
     .word    33106,33105,33112,33108
     
_kb_key_data_89_2nd:
     .word    4360,0,0,0,0,0,0,0
     .word    4361,4354,159,176,39,4184,4373,273
     .word    60,34,58,4151,123,4185,18,274
     .word    62,92,4149,4152,125,4186,151,275
     .word    4372,4147,4150,59,91,4180,4353,271
     .word    4109,4139,4141,4138,93,140,263,272
     .word    4434,4433,4440,4436
     
_kb_key_data_89_diamond:
     .word    8456,0,0,0,0,0,0,0
     .word    8457,64,8341,8316,157,8280,277,8460
     .word    156,8241,8244,8247,0,8281,95,8461
     .word    158,8242,8245,8248,169,8282,190,8462
     .word    8365,8243,8246,8249,8236,8276,8449,8463
     .word    8205,0,0,38,33,136,8455,8464
     .word    8530,8529,8536,8532 
     
     .end
     